import { FormsModule } from '@angular/forms';
import { ModalModule } from 'ngx-modal';
import { __spread } from 'tslib';
import { HttpHeaders, HttpClient, HttpClientModule } from '@angular/common/http';
import { AuthenticationService } from 'ngx-login-client';
import { WIT_API_URL, Contexts } from 'ngx-fabric8-wit';
import { Observable, throwError, Subject, of, timer } from 'rxjs';
import { catchError, map, takeWhile } from 'rxjs/operators';
import { CommonModule } from '@angular/common';
import { TooltipModule, TabsModule, AccordionModule } from 'ngx-bootstrap';
import { generate } from 'c3';
import { Injectable, Component, Input, ViewChild, ViewEncapsulation, EventEmitter, Output, NgModule, CUSTOM_ELEMENTS_SCHEMA, Directive, ElementRef, HostListener, Inject } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Constants for the StackDetailsComponent
 * The key for this mapping in constants-mapper.ts is 'stackDetails'
 * @type {?}
 */
var STACK_DETAILS_CONSTANT = {
    'title': 'Stack Reports',
    'report_failure': 'Report failed',
    'error_code': ': Error code',
    'error_text': 'Error text: ',
    'report_loading': 'Report is loading...',
    'cancel': 'Stop Loading Report',
    'load_and_return_to_pipeline': 'Continue Loading Report and Return to pipeline',
    'return_to_pipeline': 'Return to pipeline'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Constants for the StackRecommenderComponent
 * The key for this mapping in constants-mapper.ts is 'stackRecommender'
 * @type {?}
 */
var STACK_RECOMMENDER_CONSTANT = {
    'title': 'Recommendations',
    'sub_title': {
        'firstPart': 'Based on our analytics engine we found ',
        'secondPart': ' recommendations to improve your application stack:'
    },
    'create_work_item': 'Create Work Item',
    'create_work_items': 'Create Work Items',
    'view_work_item': 'View Work Item',
    'select_all_text': 'Select All',
    'no_recommendations_text': 'No recommendations.',
    'no_recommendations_suggestion': ' For your stack there are currently no recommendations. Below is some general information about it.',
    'toastDisplay': {
        'text1': 'Workitem with ID ',
        'text2': ' has been added to the backlog.'
    },
    'create_work_item_error': 'There was a error while creating work item.',
    'default_stack_name': 'An existing stack'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Constants for the OverviewComponent
 * The key for this mapping in constants-mapper.ts is 'overview'
 * @type {?}
 */
var OVERVIEW_CONSTANT = {
    'title': 'Stack Overview',
    'cve_title': 'CVEs',
    'summary': 'Summary',
    'licenseInformation': 'License Information',
    'issueMetrics': 'Issue Metrics',
    'activity': 'Activity',
    'codeMetrics': 'Code Metrics',
    'dependencies': 'Dependencies',
    'security': 'Security',
    'license': 'Total Licenses Used',
    'noDependencies': {
        'message': 'Could not build stack overview.',
        'submessage': 'There was a problem and we couldn\'t build a full stack overview analysis.'
    },
    'cvss': 'cvss',
    'score': 'score',
    'totalCvss': 'of 10',
    'total': 'Total',
    'noCve': {
        'message': 'No security alerts',
        'subMessage': 'No known CVE data found for the dependencies.'
    },
    'noLicense': 'No License data available',
    'cvssScoreTooltip': 'CVSS: Score to measure the impact of security vulnerability. In a scale from 0.0-10.0, vulnerabilities less than 7.0 are considered medium impact and more than or equal to 7.0 are considered high impact ones.',
    'othersLegend': 'Others'
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Constants for the StackComponentsComponent
 * The key for this mapping in constants-mapper.ts is 'stackComponents'
 * @type {?}
 */
var STACK_COMPONENTS_CONSTANT = {
    'title': 'Dependencies',
    'cveTooltipText': 'CVSS score over 5 is at risk',
    'noDependencies': {
        'message': 'No dependencies.',
        'submessage': 'Your application doesn\'t have any dependencies.'
    },
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * MESSAGE_MAP stores the constants against their keys.
 * eg.) stackDetails is the key to load the constants
 * (STACK_DETAILS_CONSTANT) for the component (StackDetails)
 *
 * Whenever a new constant file is being added, the same has to be imported on top and
 * entered here for the services to pick and render the respective messages.
 * @type {?}
 */
var MESSAGE_MAP = {
    'stackDetails': STACK_DETAILS_CONSTANT,
    'stackRecommender': STACK_RECOMMENDER_CONSTANT,
    'overview': OVERVIEW_CONSTANT,
    'stackComponents': STACK_COMPONENTS_CONSTANT
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var GlobalConstants = /** @class */ (function () {
    function GlobalConstants() {
    }
    /**
     * getMessages - gets the componentKey as a string and returns the Observable
     *
     * The component here is the key that enables to load the desired component.
     * For eg.) To load the messages for StackDetailsComponent,
     * call getMessages('stackDetails')
     *
     * The key mapping is found in constants-mapper.ts
     *
     * In case no match is found, it returns a null.
     */
    /**
     * getMessages - gets the componentKey as a string and returns the Observable
     *
     * The component here is the key that enables to load the desired component.
     * For eg.) To load the messages for StackDetailsComponent,
     * call getMessages('stackDetails')
     *
     * The key mapping is found in constants-mapper.ts
     *
     * In case no match is found, it returns a null.
     * @param {?} component
     * @return {?}
     */
    GlobalConstants.prototype.getMessages = /**
     * getMessages - gets the componentKey as a string and returns the Observable
     *
     * The component here is the key that enables to load the desired component.
     * For eg.) To load the messages for StackDetailsComponent,
     * call getMessages('stackDetails')
     *
     * The key mapping is found in constants-mapper.ts
     *
     * In case no match is found, it returns a null.
     * @param {?} component
     * @return {?}
     */
    function (component) {
        return Observable.create(function (observer) {
            if (MESSAGE_MAP.hasOwnProperty(component)) {
                observer.next(MESSAGE_MAP[component]);
            }
            else {
                observer.next(null);
            }
            observer.complete();
        });
    };
    GlobalConstants.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    GlobalConstants.ctorParameters = function () { return []; };
    return GlobalConstants;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StackAnalysesService = /** @class */ (function () {
    function StackAnalysesService(http, auth) {
        this.http = http;
        this.auth = auth;
        this.headers = new HttpHeaders({ 'Content-Type': 'application/json' });
        this.cvssScale = {
            low: {
                start: 0.0,
                end: 3.9,
                iconClass: 'pficon pficon-warning-triangle-o',
                displayClass: 'progress-bar-warning'
            },
            medium: {
                start: 4.0,
                end: 6.9,
                iconClass: 'pficon pficon-warning-triangle-o',
                displayClass: 'progress-bar-warning'
            },
            high: {
                start: 7.0,
                end: 10.0,
                iconClass: 'pficon pficon-warning-triangle-o warning-red-color',
                displayClass: 'progress-bar-danger'
            }
        };
        if (this.auth && this.auth.getToken && this.auth.getToken() !== null) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + this.auth.getToken());
        }
    }
    /**
     * @param {?} url
     * @param {?=} params
     * @return {?}
     */
    StackAnalysesService.prototype.getStackAnalyses = /**
     * @param {?} url
     * @param {?=} params
     * @return {?}
     */
    function (url, params) {
        // let options: any = { headers: this.headers, observe: 'response' };
        if (params && params['access_token']) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + params['access_token']);
        }
        /** @type {?} */
        var options = { headers: this.headers, observe: 'response' };
        return this.http.get(url, options)
            .pipe(map(this.extractData), catchError(this.handleError));
    };
    /**
     * @param {?} score
     * @return {?}
     */
    StackAnalysesService.prototype.getCvssObj = /**
     * @param {?} score
     * @return {?}
     */
    function (score) {
        if (score) {
            /** @type {?} */
            var iconClass = this.cvssScale.medium.iconClass;
            /** @type {?} */
            var displayClass = this.cvssScale.medium.displayClass;
            if (score >= this.cvssScale.high.start) {
                iconClass = this.cvssScale.high.iconClass;
                displayClass = this.cvssScale.high.displayClass;
            }
            return {
                iconClass: iconClass,
                displayClass: displayClass,
                value: score,
                percentScore: (score / 10 * 100)
            };
        }
    };
    /**
     * @private
     * @param {?} res
     * @return {?}
     */
    StackAnalysesService.prototype.extractData = /**
     * @private
     * @param {?} res
     * @return {?}
     */
    function (res) {
        /** @type {?} */
        var body = res.body || (/** @type {?} */ ({}));
        body['statusCode'] = res.status;
        body['statusText'] = res.statusText;
        return body;
    };
    /**
     * @private
     * @param {?} error
     * @return {?}
     */
    StackAnalysesService.prototype.handleError = /**
     * @private
     * @param {?} error
     * @return {?}
     */
    function (error) {
        /** @type {?} */
        var body = {};
        if (error.error instanceof ErrorEvent) {
            body = {
                statusText: error.error.message || error.error.toString()
            };
        }
        else if (error.status && error.statusText) {
            body = {
                status: error.status,
                statusText: error.statusText
            };
        }
        return throwError(body);
    };
    StackAnalysesService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    StackAnalysesService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: AuthenticationService }
    ]; };
    return StackAnalysesService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @param {?} data
 * @return {?}
 */
function getStackReportModel(data) {
    /** @type {?} */
    var result = data;
    return Observable.create(function (observer) {
        /** @type {?} */
        var model = (/** @type {?} */ (result));
        // Object.assign(model, result);
        observer.next(model);
        observer.complete();
    });
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var MReportSummaryTitle = /** @class */ (function () {
    function MReportSummaryTitle() {
    }
    return MReportSummaryTitle;
}());
var MTab = /** @class */ (function () {
    function MTab(title, content, active) {
        if (active === void 0) { active = false; }
        this.title = title;
        this.content = content;
        this.active = active;
    }
    return MTab;
}());
var MReportSummaryInfoEntry = /** @class */ (function () {
    function MReportSummaryInfoEntry() {
        this.infoType = 'text'; // Defaults to text, can also have chart
    }
    return MReportSummaryInfoEntry;
}());
var MReportSummaryContent = /** @class */ (function () {
    function MReportSummaryContent() {
    }
    return MReportSummaryContent;
}());
var MReportSummaryCard = /** @class */ (function () {
    function MReportSummaryCard() {
    }
    return MReportSummaryCard;
}());
var MProgressMeter = /** @class */ (function () {
    function MProgressMeter(headerText, value, bgColor, footerText, width) {
        this.headerText = headerText;
        this.value = value;
        this.bgColor = bgColor;
        this.footerText = footerText;
        this.width = width;
    }
    return MProgressMeter;
}());
/**
 * Bottom Section
 */
var /**
 * Bottom Section
 */
MGithub = /** @class */ (function () {
    function MGithub(contributors, forks, depRepos, stars, usage, users) {
        if (contributors === void 0) { contributors = -1; }
        if (forks === void 0) { forks = -1; }
        if (depRepos === void 0) { depRepos = -1; }
        if (stars === void 0) { stars = -1; }
        if (usage === void 0) { usage = -1; }
        this.contributors = contributors;
        this.forks = forks;
        this.depRepos = depRepos;
        this.stars = stars;
        this.usage = usage;
        this.users = users;
    }
    return MGithub;
}());
var MOsio = /** @class */ (function () {
    function MOsio(usage) {
        if (usage === void 0) { usage = -1; }
        this.usage = usage;
    }
    return MOsio;
}());
var MCrowdSourcing = /** @class */ (function () {
    function MCrowdSourcing(tags, canSuggestTags) {
        if (canSuggestTags === void 0) { canSuggestTags = true; }
        this.tags = tags;
        this.canSuggestTags = canSuggestTags;
    }
    return MCrowdSourcing;
}());
var MSecurityIssue = /** @class */ (function () {
    function MSecurityIssue(cvss, cve) {
        this.cvss = cvss;
        this.cve = cve;
    }
    return MSecurityIssue;
}());
var MSecurityDetails = /** @class */ (function () {
    function MSecurityDetails(highestIssue, progressReport, totalIssues) {
        if (highestIssue === void 0) { highestIssue = null; }
        if (progressReport === void 0) { progressReport = null; }
        if (totalIssues === void 0) { totalIssues = null; }
        this.highestIssue = highestIssue;
        this.progressReport = progressReport;
        this.totalIssues = totalIssues;
    }
    return MSecurityDetails;
}());
var MLicenseInformation = /** @class */ (function () {
    function MLicenseInformation(licenses, unknownLicenses, hasLicenseIssue, licensesAffected) {
        if (licensesAffected === void 0) { licensesAffected = null; }
        this.licenses = licenses;
        this.unknownLicenses = unknownLicenses;
        this.hasLicenseIssue = hasLicenseIssue;
        this.licensesAffected = licensesAffected;
    }
    return MLicenseInformation;
}());
var MWorkItem = /** @class */ (function () {
    function MWorkItem(isWorkItemCreated, url) {
        if (isWorkItemCreated === void 0) { isWorkItemCreated = false; }
        this.isWorkItemCreated = isWorkItemCreated;
        this.url = url;
    }
    return MWorkItem;
}());
var MComponentInformation = /** @class */ (function () {
    function MComponentInformation(name, currentVersion, latestVersion, securityDetails, hasSecurityIssue, isUsageOutlier, hasLicenseIssue, licenses, crowdSourcing, github, osio, action, needsExpansion, recommendation, isOpen, licenseInformation, ecosystem, manifestFilePath, workItem) {
        if (currentVersion === void 0) { currentVersion = 'NA'; }
        if (latestVersion === void 0) { latestVersion = 'NA'; }
        if (securityDetails === void 0) { securityDetails = null; }
        if (action === void 0) { action = null; }
        if (needsExpansion === void 0) { needsExpansion = true; }
        if (recommendation === void 0) { recommendation = null; }
        if (isOpen === void 0) { isOpen = false; }
        if (workItem === void 0) { workItem = new MWorkItem(); }
        this.name = name;
        this.currentVersion = currentVersion;
        this.latestVersion = latestVersion;
        this.securityDetails = securityDetails;
        this.hasSecurityIssue = hasSecurityIssue;
        this.isUsageOutlier = isUsageOutlier;
        this.hasLicenseIssue = hasLicenseIssue;
        this.licenses = licenses;
        this.crowdSourcing = crowdSourcing;
        this.github = github;
        this.osio = osio;
        this.action = action;
        this.needsExpansion = needsExpansion;
        this.recommendation = recommendation;
        this.isOpen = isOpen;
        this.licenseInformation = licenseInformation;
        this.ecosystem = ecosystem;
        this.manifestFilePath = manifestFilePath;
        this.workItem = workItem;
    }
    return MComponentInformation;
}());
var MStackLicenseConflictDetails = /** @class */ (function () {
    function MStackLicenseConflictDetails(conflictedWithLicense, conflictedWithComponent, conflictedForLicense) {
        this.conflictedWithLicense = conflictedWithLicense;
        this.conflictedWithComponent = conflictedWithComponent;
        this.conflictedForLicense = conflictedForLicense;
    }
    return MStackLicenseConflictDetails;
}());
var MConflictsWithInLicenses = /** @class */ (function () {
    function MConflictsWithInLicenses(license1, license2) {
        this.license1 = license1;
        this.license2 = license2;
    }
    return MConflictsWithInLicenses;
}());
var MLicensesAffected = /** @class */ (function () {
    function MLicensesAffected(affectedLicenses, conflictType, conflictDetails) {
        if (affectedLicenses === void 0) { affectedLicenses = null; }
        if (conflictDetails === void 0) { conflictDetails = null; }
        this.affectedLicenses = affectedLicenses;
        this.conflictType = conflictType;
        this.conflictDetails = conflictDetails;
    }
    return MLicensesAffected;
}());
var MRecommendationInformation = /** @class */ (function () {
    function MRecommendationInformation(type, // Alternate or companion
    reason, feedback, confidenceScore, componentInformation, manifestFilePath, workItem) {
        if (reason === void 0) { reason = null; }
        if (feedback === void 0) { feedback = null; }
        if (workItem === void 0) { workItem = new MWorkItem(); }
        this.type = type;
        this.reason = reason;
        this.feedback = feedback;
        this.confidenceScore = confidenceScore;
        this.componentInformation = componentInformation;
        this.manifestFilePath = manifestFilePath;
        this.workItem = workItem;
    }
    return MRecommendationInformation;
}());
var MComponentDetails = /** @class */ (function () {
    function MComponentDetails(componentInformation, recommendationInformation) {
        if (componentInformation === void 0) { componentInformation = null; }
        if (recommendationInformation === void 0) { recommendationInformation = null; }
        this.componentInformation = componentInformation;
        this.recommendationInformation = recommendationInformation;
    }
    return MComponentDetails;
}());
var MComponentHeaderColumn = /** @class */ (function () {
    function MComponentHeaderColumn(identifier, text, className, isSortable, isDragable) {
        if (isSortable === void 0) { isSortable = false; }
        if (isDragable === void 0) { isDragable = false; }
        this.identifier = identifier;
        this.text = text;
        this.className = className;
        this.isSortable = isSortable;
        this.isDragable = isDragable;
    }
    return MComponentHeaderColumn;
}());
var MReportInformation = /** @class */ (function () {
    function MReportInformation(identifier, name, type, headers, componentDetails) {
        this.identifier = identifier;
        this.name = name;
        this.type = type;
        this.headers = headers;
        this.componentDetails = componentDetails;
    }
    return MReportInformation;
}());
var MCardDetails = /** @class */ (function () {
    function MCardDetails() {
        this.isMultiple = true; // This is for tabs, in case it is false, report won't be rendered inside tabs
    }
    return MCardDetails;
}());
var MGenericStackInformation = /** @class */ (function () {
    function MGenericStackInformation(stackId, baseUrl) {
        this.stackId = stackId;
        this.baseUrl = baseUrl;
    }
    return MGenericStackInformation;
}());
var MFeedbackTemplate = /** @class */ (function () {
    function MFeedbackTemplate(stack_id, recommendation_type, package_name, feedback_type, ecosystem) {
        if (feedback_type === void 0) { feedback_type = null; }
        this.stack_id = stack_id;
        this.recommendation_type = recommendation_type;
        this.package_name = package_name;
        this.feedback_type = feedback_type;
        this.ecosystem = ecosystem;
    }
    return MFeedbackTemplate;
}());
var MComponentFeedback = /** @class */ (function () {
    function MComponentFeedback(feedbackTemplate, baseUrl) {
        this.feedbackTemplate = feedbackTemplate;
        this.baseUrl = baseUrl;
    }
    return MComponentFeedback;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryUtils = /** @class */ (function () {
    function ReportSummaryUtils() {
        var _a;
        this.notification = {
            warning: {
                bg: '#f5a625',
                icon: 'pficon-warning-triangle-o'
            },
            good: {
                bg: '#6dc663',
                icon: 'fa fa-check'
            }
        };
        this.colors = {
            security: {
                warning: '#d1011c',
                moderate: '#f5a625'
            },
            confidence: {
                good: '#6dc663'
            }
        };
        this.cardTypes = {
            SECURITY: 'security',
            INSIGHTS: 'insights',
            LICENSES: 'licenses',
            COMP_DETAILS: 'compDetails'
        };
        this.titleAndDescription = (_a = {},
            _a[this.cardTypes.SECURITY] = {
                title: 'Dependencies with security issues in your stack',
                description: 'Dependencies with high common vulnerabilities and exposures (CVE) score.  Click this card to see the details of all CVE(s).',
                descriptionShort: 'Click this card to see details of CVEs in your stack.'
            },
            _a[this.cardTypes.INSIGHTS] = {
                title: 'Insights on alternate or additional dependencies that can augment your stack',
                description: 'Suggested dependencies that can be added to your application stack or replace current dependencies with alternate one. Click to see details.',
                descriptionShort: 'Click this card to see suggested dependencies that complement your stack.'
            },
            _a[this.cardTypes.LICENSES] = {
                title: 'License details of dependencies in your stack',
                description: 'Recommended license for your application stack, flag any unknown/restrictive license(s) present. Click this card to see the detailed information.',
                descriptionShort: 'Click this card to see detailed license information for your stack.'
            },
            _a[this.cardTypes.COMP_DETAILS] = {
                title: 'Dependency details of your manifest file',
                description: 'Dependencies analyzed based on versions and popularity. Click this card to see security, license and usage information for each dependency.'
            },
            _a);
    }
    /**
     * @return {?}
     */
    ReportSummaryUtils.prototype.newCardInstance = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var newCard = new MReportSummaryCard();
        newCard.reportSummaryContent = new MReportSummaryContent();
        newCard.reportSummaryTitle = new MReportSummaryTitle();
        return newCard;
    };
    /**
     * @param {?} userStackInfo
     * @return {?}
     */
    ReportSummaryUtils.prototype.getSecurityReportCard = /**
     * @param {?} userStackInfo
     * @return {?}
     */
    function (userStackInfo) {
        /** @type {?} */
        var securityCard = this.newCardInstance();
        securityCard.identifier = this.cardTypes.SECURITY;
        securityCard.reportSummaryTitle.titleIcon = 'fa fa-shield';
        securityCard.reportSummaryDescription =
            this.titleAndDescription[this.cardTypes.SECURITY].description;
        securityCard.reportSummaryDescriptionShort =
            this.titleAndDescription[this.cardTypes.SECURITY].descriptionShort;
        securityCard.reportSummaryTitle.titleText = 'Security Issues';
        securityCard.reportSummaryContent.infoEntries = [];
        if (userStackInfo &&
            userStackInfo.analyzed_dependencies &&
            userStackInfo.analyzed_dependencies.length > 0) {
            /** @type {?} */
            var securityIssues_1 = 0;
            /** @type {?} */
            var maxIssue_1 = null;
            /** @type {?} */
            var temp_1 = null;
            /** @type {?} */
            var analyzedDependencies = void 0;
            analyzedDependencies = userStackInfo.analyzed_dependencies;
            analyzedDependencies.forEach(function (analyzed) {
                if (analyzed.security && analyzed.security.length > 0) {
                    /** @type {?} */
                    var currSecurity = analyzed.security;
                    temp_1 = currSecurity.reduce(function (a, b) {
                        return parseFloat(a.CVSS) < parseFloat(b.CVSS) ? b : a;
                    });
                    if (temp_1) {
                        if (maxIssue_1 === null || maxIssue_1.CVSS < temp_1.CVSS) {
                            maxIssue_1 = temp_1;
                        }
                    }
                    securityIssues_1 += currSecurity.length;
                }
            });
            /** @type {?} */
            var totalComponentsWithMaxScore_1 = 0;
            analyzedDependencies.forEach(function (analyzed) {
                if (analyzed.security && analyzed.security.length > 0) {
                    /** @type {?} */
                    var currSecurity = analyzed.security;
                    /** @type {?} */
                    var filters = void 0;
                    filters = currSecurity.filter(function (security) {
                        return security.CVSS === maxIssue_1.CVSS;
                    });
                    totalComponentsWithMaxScore_1 += filters ? filters.length : 0;
                }
            });
            /** @type {?} */
            var totalIssuesEntry = new MReportSummaryInfoEntry();
            totalIssuesEntry.infoText = 'Total issues found';
            totalIssuesEntry.infoValue = securityIssues_1;
            securityCard.reportSummaryContent.infoEntries.push(totalIssuesEntry);
            if (maxIssue_1) {
                /** @type {?} */
                var securityColor = Number(maxIssue_1.CVSS) >= 7 ? this.colors.security.warning : this.colors.security.moderate;
                /** @type {?} */
                var maxIssueEntry = new MReportSummaryInfoEntry();
                maxIssueEntry.infoText = 'Highest CVSS Score';
                maxIssueEntry.infoValue = maxIssue_1.CVSS;
                maxIssueEntry.infoType = 'progress';
                maxIssueEntry.config = {
                    headerText: maxIssue_1.CVSS + ' / ' + 10,
                    value: Number(maxIssue_1.CVSS),
                    bgColor: securityColor,
                    footerText: 'No. of dependencies with this CVSS Score: ' + totalComponentsWithMaxScore_1,
                    width: Number(maxIssue_1.CVSS) * 10
                };
                securityCard.reportSummaryContent.infoEntries.push(maxIssueEntry);
                securityCard.reportSummaryTitle.notificationIcon = this.notification.warning.icon;
                securityCard.reportSummaryTitle.notificationIconBgColor = securityColor;
                securityCard.hasWarning = true;
                securityCard.severity = Number(maxIssue_1.CVSS) >= 7 ? 1 : 2;
            }
            else {
                // securityCard.reportSummaryTitle.notificationIcon = this.notification.good.icon;
                // securityCard.reportSummaryTitle.notificationIconBgColor = this.notification.good.bg;
                securityCard.hasWarning = false;
            }
        }
        return securityCard;
    };
    /**
     * @param {?} recommendation
     * @return {?}
     */
    ReportSummaryUtils.prototype.getInsightsReportCard = /**
     * @param {?} recommendation
     * @return {?}
     */
    function (recommendation) {
        /** @type {?} */
        var insightsCard = this.newCardInstance();
        insightsCard.identifier = this.cardTypes.INSIGHTS;
        insightsCard.reportSummaryTitle.titleText = 'Insights';
        insightsCard.reportSummaryTitle.titleIcon = 'pficon-zone';
        insightsCard.reportSummaryDescription = this.titleAndDescription[this.cardTypes.INSIGHTS].description;
        insightsCard.reportSummaryDescriptionShort = this.titleAndDescription[this.cardTypes.INSIGHTS].descriptionShort;
        insightsCard.reportSummaryContent.infoEntries = [];
        /** @type {?} */
        var usageOutliersCount = 0;
        /** @type {?} */
        var companionCount = 0;
        if (recommendation) {
            /** @type {?} */
            var usage = recommendation.usage_outliers;
            usageOutliersCount = usage ? usage.length : 0;
            companionCount = recommendation.companion ? recommendation.companion.length : 0;
            /** @type {?} */
            var totalInsights = new MReportSummaryInfoEntry();
            totalInsights.infoText = 'Total Insights';
            totalInsights.infoValue = usageOutliersCount + companionCount;
            insightsCard.reportSummaryContent.infoEntries.push(totalInsights);
            /** @type {?} */
            var outliersInsights = new MReportSummaryInfoEntry();
            outliersInsights.infoText = 'Usage Outliers';
            outliersInsights.infoValue = usageOutliersCount;
            insightsCard.reportSummaryContent.infoEntries.push(outliersInsights);
            /** @type {?} */
            var companionInsights = new MReportSummaryInfoEntry();
            companionInsights.infoText = 'Companion Dependencies';
            companionInsights.infoValue = companionCount;
            insightsCard.reportSummaryContent.infoEntries.push(companionInsights);
            // insightsCard.reportSummaryTitle.notificationIcon = this.notification.good.icon;
            // insightsCard.reportSummaryTitle.notificationIconBgColor = this.notification.good.bg;
            insightsCard.hasWarning = false;
            if (usageOutliersCount > 0) {
                insightsCard.reportSummaryTitle.notificationIcon = this.notification.warning.icon;
                insightsCard.reportSummaryTitle.notificationIconBgColor = this.colors.security.moderate;
                insightsCard.hasWarning = true;
            }
        }
        return insightsCard;
    };
    /**
     * @param {?} userStackInfo
     * @return {?}
     */
    ReportSummaryUtils.prototype.getLicensesReportCard = /**
     * @param {?} userStackInfo
     * @return {?}
     */
    function (userStackInfo) {
        /** @type {?} */
        var licensesCard = this.newCardInstance();
        licensesCard.identifier = this.cardTypes.LICENSES;
        licensesCard.reportSummaryTitle.titleText = 'Licenses';
        licensesCard.reportSummaryTitle.titleIcon = 'fa fa-file-text-o';
        licensesCard.reportSummaryDescription = this.titleAndDescription[this.cardTypes.LICENSES].description;
        licensesCard.reportSummaryDescriptionShort = this.titleAndDescription[this.cardTypes.LICENSES].descriptionShort;
        licensesCard.reportSummaryContent.infoEntries = [];
        if (userStackInfo &&
            userStackInfo.license_analysis) {
            /** @type {?} */
            var licenseAnalysis = void 0;
            licenseAnalysis = userStackInfo.license_analysis;
            /** @type {?} */
            var stackLicense = new MReportSummaryInfoEntry();
            stackLicense.infoText = 'Recommended License';
            /** @type {?} */
            var stackLicenses = licenseAnalysis.f8a_stack_licenses;
            if (stackLicenses) {
                if (stackLicenses.length > 0) {
                    stackLicense.infoValue = stackLicenses[0];
                }
                else {
                    stackLicense.infoValue = 'None';
                    if (licenseAnalysis.status && licenseAnalysis.status.toLowerCase() === 'failure') {
                        stackLicense.infoValue = 'Unknown';
                    }
                }
            }
            licensesCard.reportSummaryContent.infoEntries.push(stackLicense);
            /** @type {?} */
            var conflictLicense = new MReportSummaryInfoEntry();
            conflictLicense.infoText = 'License Conflicts';
            /** @type {?} */
            var conflictLicenses = licenseAnalysis.conflict_packages;
            conflictLicense.infoValue = conflictLicenses ? conflictLicenses.length : 0;
            if (stackLicense.infoValue === 'Unknown') {
                conflictLicense.infoValue = 'NA';
            }
            licensesCard.reportSummaryContent.infoEntries.push(conflictLicense);
            /** @type {?} */
            var unknownLicense = new MReportSummaryInfoEntry();
            unknownLicense.infoText = 'Unknown Licenses';
            /** @type {?} */
            var unknownLicenses = licenseAnalysis.unknown_licenses.really_unknown;
            unknownLicense.infoValue = unknownLicenses ? unknownLicenses.length : 0;
            if (stackLicense.infoValue === 'Unknown') {
                unknownLicense.infoValue = 'NA';
            }
            licensesCard.reportSummaryContent.infoEntries.push(unknownLicense);
            if (stackLicense.infoValue !== 'NONE' && stackLicense.infoValue !== 'Unknown') {
                /** @type {?} */
                var restrictiveLicenses = new MReportSummaryInfoEntry();
                restrictiveLicenses.infoText = 'Restrictive Licenses';
                /** @type {?} */
                var restrictive = licenseAnalysis.outlier_packages;
                restrictiveLicenses.infoValue = restrictive ? restrictive.length : 0;
                licensesCard.reportSummaryContent.infoEntries.push(restrictiveLicenses);
            }
            // licensesCard.reportSummaryTitle.notificationIcon = this.notification.good.icon;
            // licensesCard.reportSummaryTitle.notificationIconBgColor = this.notification.good.bg;
            licensesCard.hasWarning = false;
            if (conflictLicenses.length > 0 || unknownLicenses.length > 0) {
                licensesCard.reportSummaryTitle.notificationIcon = this.notification.warning.icon;
                licensesCard.reportSummaryTitle.notificationIconBgColor = this.notification.warning.bg;
                licensesCard.hasWarning = true;
            }
        }
        return licensesCard;
    };
    return ReportSummaryUtils;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SaveState = /** @class */ (function () {
    function SaveState() {
    }
    SaveState.ELEMENTS = [];
    SaveState.isModalOpened = false;
    return SaveState;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CommonService = /** @class */ (function () {
    function CommonService() {
        this.inshortCardClicked = new Subject();
    }
    /**
     * @return {?}
     */
    CommonService.prototype.shortCardClicked = /**
     * @return {?}
     */
    function () {
        this.inshortCardClicked.next(true);
    };
    CommonService.decorators = [
        { type: Injectable }
    ];
    return CommonService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * New Stack Report Revamp - End
 */
var StackDetailsComponent = /** @class */ (function () {
    function StackDetailsComponent(stackAnalysisService, commonService) {
        this.stackAnalysisService = stackAnalysisService;
        this.commonService = commonService;
        /**
         * New Stack Report Revamp - Begin
         */
        this.cardDetails = {};
        this.genericInformation = null;
        /**
         * New Stack Report Revamp - End
         */
        this.errorMessage = {};
        this.cache = '';
        this.modalHeader = null;
        this.componentLevelInformation = {};
        this.userComponentInformation = [];
        this.companionLevelRecommendation = {};
        this.dataLoaded = false;
        this.recommendationsArray = [];
        this.stackLevelOutliers = {};
        this.companionLevel = {};
        this.componentLevel = {};
        this.componentFilterBy = '';
        this.customClass = 'accordion-custom';
        this.analysis = {};
        this.feedbackConfig = {};
        this.tabs = [];
        this.showF = true;
        this.userStackInformationArray = [];
        this.reportSummaryUtils = new ReportSummaryUtils();
    }
    /**
     * New Stack Report Revamp - Begin
     */
    /**
     * New Stack Report Revamp - Begin
     * @param {?} cardDetails
     * @return {?}
     */
    StackDetailsComponent.prototype.handleCardClick = /**
     * New Stack Report Revamp - Begin
     * @param {?} cardDetails
     * @return {?}
     */
    function (cardDetails) {
        this.genericInformation = new MGenericStackInformation(this.stackId, this.getBaseUrl(this.stack));
        this.cardDetails = cardDetails;
    };
    /**
     * New Stack Report Revamp - End
     */
    /**
     * New Stack Report Revamp - End
     * @param {?} event
     * @return {?}
     */
    StackDetailsComponent.prototype.showStackModal = /**
     * New Stack Report Revamp - End
     * @param {?} event
     * @return {?}
     */
    function (event) {
        if (event) {
            event.preventDefault();
        }
        this.modalStackModule.open();
    };
    /**
     * Gets triggered on close of modal,
     * Clears the existing states to make it proper on open
     */
    /**
     * Gets triggered on close of modal,
     * Clears the existing states to make it proper on open
     * @return {?}
     */
    StackDetailsComponent.prototype.handleModalClose = /**
     * Gets triggered on close of modal,
     * Clears the existing states to make it proper on open
     * @return {?}
     */
    function () {
        this.resetFields();
        SaveState.isModalOpened = false;
    };
    /**
     * @param {?} tab
     * @return {?}
     */
    StackDetailsComponent.prototype.tabSelection = /**
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        if (tab) {
            tab['active'] = true;
            /** @type {?} */
            var currentIndex = tab['index'];
            /** @type {?} */
            var recommendations = this.recommendationsArray[currentIndex];
            /** @type {?} */
            var alternate = 0;
            /** @type {?} */
            var companion = 0;
            if (recommendations) {
                this.stackLevelOutliers = {
                    'usage': recommendations.usage_outliers
                };
                this.companionLevelRecommendation = {
                    dependencies: recommendations.companion,
                    manifestinfo: tab.content.manifest_name,
                    licenseAnalysis: tab.content.user_stack_info.license_analysis
                };
                alternate = recommendations.alternate ? recommendations.alternate.length : 0;
                companion = recommendations.companion ? recommendations.companion.length : 0;
            }
            /** @type {?} */
            var total = 0;
            /** @type {?} */
            var analyzed = 0;
            /** @type {?} */
            var unknown = 0;
            if (tab.content && tab.content.user_stack_info) {
                /** @type {?} */
                var userStackInfo = tab.content.user_stack_info;
                if (userStackInfo.dependencies) {
                    analyzed = userStackInfo.analyzed_dependencies.length;
                }
                if (userStackInfo.analyzed_dependencies) {
                    total = userStackInfo.dependencies.length;
                }
                if (userStackInfo.unknown_dependencies) {
                    unknown = userStackInfo.unknown_dependencies.length;
                }
            }
            this.analysis = {
                stackLevel: 'Total: ' + total + ' | Analyzed: ' + analyzed + ' | Unknown: ' +
                    unknown,
                alternate: '[' + alternate + ' alternate dependencies match your stack ' +
                    'composition and may be more appropriate]',
                companion: '[' + companion + ' additional dependencies are often used by ' +
                    'similar stacks]'
            };
            this.componentLevelInformation = {
                recommendations: recommendations,
                dependencies: tab.content.user_stack_info.analyzed_dependencies,
                manifestinfo: tab.content.manifest_name,
                licenseAnalysis: tab.content.user_stack_info.license_analysis
            };
            // Select the first card by default
            if (SaveState && SaveState.ELEMENTS && SaveState.ELEMENTS.length > 0) {
                if (SaveState.ELEMENTS[currentIndex * 4]) {
                    SaveState.ELEMENTS[currentIndex * 4].click();
                }
            }
        }
    };
    /**
     * @param {?} tab
     * @return {?}
     */
    StackDetailsComponent.prototype.tabDeSelection = /**
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        if (tab) {
            tab['active'] = false;
        }
    };
    /**
     * @return {?}
     */
    StackDetailsComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        if (this.stack && this.stack !== this.cache) {
            this.cache = this.stack;
            this.resetFields();
            if (this.stack && this.stack.split('/').length > 0) {
                /** @type {?} */
                var chunks = this.stack.split('/');
                /** @type {?} */
                var count = chunks.length;
                this.stackId = chunks[count - 1];
            }
            // this.init(this.stack);
            this.initFeedback();
            this.componentLevel = {
                header: 'Analysis of your application stack',
                subHeader: 'Recommended alternative dependencies'
            };
            this.companionLevel = {
                header: 'Possible companion dependencies',
                subHeader: 'Consider theses additional dependencies'
            };
            this.displayName = this.displayName || 'Stack Report';
        }
        if (this.showFlags === 'false') {
            this.showF = false;
        }
    };
    /**
     * @return {?}
     */
    StackDetailsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (SaveState.isModalOpened === false) {
            SaveState.isModalOpened = true;
            this.commonService.inshortCardClicked
                .subscribe(function (response) {
                _this.showStackModal(null);
            });
        }
    };
    /**
     * @param {?} filterBy
     * @return {?}
     */
    StackDetailsComponent.prototype.handleChangeFilter = /**
     * @param {?} filterBy
     * @return {?}
     */
    function (filterBy) {
        this.componentFilterBy = filterBy.filterBy;
    };
    /**
     * New Revamp - Begin
     * https://recommender.api.openshift.io/api/v1/stack-analyses/
     */
    /**
     * New Revamp - Begin
     * https://recommender.api.openshift.io/api/v1/stack-analyses/
     * @private
     * @param {?} url
     * @return {?}
     */
    StackDetailsComponent.prototype.getBaseUrl = /**
     * New Revamp - Begin
     * https://recommender.api.openshift.io/api/v1/stack-analyses/
     * @private
     * @param {?} url
     * @return {?}
     */
    function (url) {
        if (url && url !== '') {
            /** @type {?} */
            var splitter = 'api/v1';
            return url.indexOf(splitter) !== -1 ? url.split(splitter)[0] : '';
        }
        return '';
    };
    /**
     * New Revamp - End
     */
    /**
     * New Revamp - End
     * @private
     * @param {?} error
     * @return {?}
     */
    StackDetailsComponent.prototype.handleError = /**
     * New Revamp - End
     * @private
     * @param {?} error
     * @return {?}
     */
    function (error) {
        this.errorMessage = error;
        this.modalHeader = error.title;
        this.dataLoaded = true;
    };
    /**
     * @private
     * @return {?}
     */
    StackDetailsComponent.prototype.initFeedback = /**
     * @private
     * @return {?}
     */
    function () {
        this.feedbackConfig = {
            name: 'Feedback',
            stackId: this.stackId,
            title: 'Tell us your experience',
            poll: [{
                    question: 'How useful do you find this?',
                    type: 'rating'
                }, {
                    question: 'How likely do you recommend this to others?',
                    type: 'rating'
                }, {
                    question: 'Tell us more',
                    type: 'text'
                }]
        };
    };
    /**
     * @private
     * @return {?}
     */
    StackDetailsComponent.prototype.resetFields = /**
     * @private
     * @return {?}
     */
    function () {
        this.tabs.length = 0;
        this.dataLoaded = false;
        this.errorMessage = null;
        this.recommendationsArray = [];
        this.stackLevelOutliers = {};
        this.componentLevelInformation = {};
        this.companionLevelRecommendation = {};
        this.cacheResponse = {};
        SaveState.ELEMENTS = [];
        this.openStackModalFromCard = 'false';
    };
    /**
     * @private
     * @param {?} data
     * @return {?}
     */
    StackDetailsComponent.prototype.handleResponse = /**
     * @private
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        this.errorMessage = null;
        this.tabs = [];
        if (data && (!data.hasOwnProperty('error') && Object.keys(data).length !== 0)) {
            /** @type {?} */
            var resultInformation = getStackReportModel(data);
            resultInformation.subscribe(function (response) {
                /** @type {?} */
                var result = response.result;
                _this.totalManifests = result.length;
                if (_this.totalManifests > 0) {
                    _this.userStackInformationArray = result.map(function (r) { return r.user_stack_info; });
                    result.forEach(function (r, index) {
                        /** @type {?} */
                        var warning = _this.ifManifestHasWarning(r);
                        /** @type {?} */
                        var tab = {
                            title: r.manifest_file_path,
                            content: r,
                            index: index,
                            hasWarning: warning.has,
                            severity: warning.severity
                        };
                        _this.tabs.push(tab);
                        _this.recommendationsArray.push(r.recommendation);
                    });
                    _this.modalHeader = 'Updated just now';
                    _this.dataLoaded = true;
                    _this.tabSelection(_this.tabs[0]);
                }
            });
        }
        else if (data && data.hasOwnProperty('error')) {
            this.handleError({
                message: 'Analysis for your stack is in progress ...',
                code: data.statusCode,
                title: 'Report is getting ready.'
            });
        }
        else {
            this.handleError({
                message: data.error,
                code: data.statusCode,
                title: 'Updating ...'
            });
        }
    };
    /**
     * @private
     * @param {?} manifest
     * @return {?}
     */
    StackDetailsComponent.prototype.ifManifestHasWarning = /**
     * @private
     * @param {?} manifest
     * @return {?}
     */
    function (manifest) {
        /** @type {?} */
        var securityInfo = this.reportSummaryUtils.getSecurityReportCard(manifest.user_stack_info);
        /** @type {?} */
        var isSecurityWarning = securityInfo.hasWarning;
        /** @type {?} */
        var isInsightsWarning = this.reportSummaryUtils.getInsightsReportCard(manifest.recommendation).hasWarning;
        /** @type {?} */
        var isLicenseWarning = this.reportSummaryUtils.getLicensesReportCard(manifest.user_stack_info).hasWarning;
        return {
            has: isSecurityWarning || isInsightsWarning || isLicenseWarning,
            severity: (isSecurityWarning && securityInfo.severity) || 2
        };
    };
    /**
     * @return {?}
     */
    StackDetailsComponent.prototype.init = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.stackResponse && this.cacheResponse !== this.stackResponse) {
            this.cacheResponse = this.stackResponse;
            // Change this to some other logic
            setTimeout(function () {
                _this.handleResponse(_this.stackResponse);
            }, 1000);
        }
        else {
            console.log('stack details', this.stack, this.gatewayConfig);
            if (this.stack && this.stack !== '') {
                this.stackAnalysisService
                    .getStackAnalyses(this.stack, this.gatewayConfig)
                    .subscribe(function (data) {
                    _this.handleResponse(data);
                }, function (error) {
                    /** @type {?} */
                    var title = '';
                    if (error.status >= 500) {
                        title = 'Something unexpected happened';
                    }
                    else if (error.status === 404) {
                        title = 'You are looking for something which isn\'t there';
                    }
                    else if (error.status === 401) {
                        title = 'You don\'t seem to have sufficient privileges to access this';
                    }
                    title = 'Report failed ...'; // Check if just this message is enough.
                    _this.handleError({
                        message: error.statusText,
                        status: error.status,
                        title: title
                    });
                });
            }
        }
    };
    StackDetailsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'stack-details',
                    // providers: [StackAnalysesService],
                    encapsulation: ViewEncapsulation.None,
                    template: "<div class=\"stack-report\">\n  <a [ngClass]=\"{'stack-reports-btn': true, 'pipeline-case': showF}\" (click)=\"showStackModal($event)\">{{displayName}}</a>\n  <pipleine-insights-details (onStackResponse)=\"stackResponse = $event\" (click)=\"showStackModal($event)\" *ngIf=\"stack && showF\" [url]=\"stack\"></pipleine-insights-details>\n  <modal #stackModule title=\"Stack report for {{appName}}, Build #{{buildNumber}}\" modalClass=\"modal-lg modal-fullscreen modal-width-class\" (onClose)=\"handleModalClose();\" (onOpen)=\"init();\">\n    <modal-content>\n      <div>\n        <tabset *ngIf=\"dataLoaded\">\n            <tab *ngFor=\"let tabz of tabs\"\n                (select)=\"tabSelection(tabz)\"\n                (deselect)=\"tabDeSelection(tabz)\"\n                [customClass]=\"tabz.active ? 'active-menu-item' : 'inactive-menu'\">\n                <ng-template tabHeading>\n                  <i *ngIf=\"tabz.hasWarning\" [ngClass]=\"{'pficon-warning-triangle-o': true, 'icon-severe': tabz.severity === 1, 'icon-moderate': tabz.severity === 2}\"></i>\n                  <span [innerHtml]=\"tabz.title\" style=\"margin-left: 5px\"></span>\n                </ng-template>\n                <!-- Stack Report Design Revamp - BEGIN -->\n                <analytics-report-summary (onCardClick)=\"handleCardClick($event)\" [report]=\"tabz.content\"></analytics-report-summary>\n                <card-details [genericInformation]=\"genericInformation && genericInformation\" *ngIf=\"cardDetails\" [cardDetails]=\"cardDetails\" [repoInfo]=\"repoInfo\"></card-details>\n                <!-- Stack Report Design Revamp - END -->\n            </tab>\n        </tabset>\n      </div>\n      <div *ngIf=\"!dataLoaded\" class=\"pre-loader\">\n        <div class=\"pre-loader-spinner spinner spinner-lg\"></div>\n      </div>\n      <div class=\"error-msg blank-slate-pf\" *ngIf=\"errorMessage\">\n        <div [hidden]=\"!errorMessage.status\">\n          <div class=\"warning-icon blank-slate-pf-icon\">\n            <i class=\"pficon-warning-triangle-o\"></i>\n          </div>\n          <h1>\n            Report failed\n            <span *ngIf=\"errorMessage.status\">{{errorMessage.status}}</span>\n          </h1>\n          <p>\n            Error text: {{errorMessage.message}}\n          </p>\n        </div>\n        <div [hidden]=\"errorMessage.status\">\n          <h3>\n            Report is getting ready. Please revisit.\n          </h3>\n          <p>{{errorMessage.message}}</p>\n        </div>\n        <div [hidden]=\"errorMessage.status\" class=\"blank-slate-pf-secondary-action\">\n          <button class=\"btn btn-default\" (click)=\"stackModule.close()\">Cancel</button>\n          <button class=\"btn btn-primary\" (click)=\"stackModule.close()\">Return to Pipeline</button>\n        </div>\n        <div [hidden]=\"!errorMessage.status\" class=\"blank-slate-pf-secondary-action\">\n          <button class=\"btn btn-primary\" (click)=\"stackModule.close()\">Return to Pipeline</button>\n        </div>\n      </div>\n    </modal-content>\n  </modal>\n</div>\n",
                    styles: [".stack-report .pipeline-case{padding:3px 10px;margin-left:20px;border:1px solid #ededed}.stack-report .modal-header{background-color:#030303;color:#fff}.stack-report .modal-header .close{font-size:50px;padding:0;position:absolute;right:10px;top:0;font-weight:100;color:#fff}.stack-report .modal-body{padding:unset}.stack-report .modal-body .tab-container .nav-tabs{border:none;background:#030303;color:#fff}.stack-report .modal-body .tab-container .nav-tabs .active-menu-item .nav-link.active{background-color:inherit;color:inherit;border:none;box-shadow:inset -10px -14px 0 -10px #39a5dc}.stack-report .modal-body .tab-container .nav-tabs li a{border:0}.stack-report .modal-body .tab-container .nav-tabs li a:hover{border:0;color:inherit}.stack-report .modal-body .tab-container .icon-moderate:before{color:#f5a625}.stack-report .modal-body .tab-container .icon-severe:before{color:#d1011c}.stack-report .stack-reports-btn{cursor:pointer}.stack-report .modal-width-class{width:95%}.stack-report .accordion-indicator{top:unset;margin-left:10px}.stack-report .active-menu-item .nav-link.active{color:#000;font-weight:700}.stack-report .pre-loader{position:absolute;top:0;left:0;bottom:0;right:0;background:rgba(255,255,255,.5);z-index:99}.stack-report .pre-loader .pre-loader-spinner{top:50%}.stack-report .error-msg{text-align:center;background:#fff;border:none}.stack-report .error-msg .warning-icon{font-size:6em}.stack-report .error-msg .warning-icon i:before{color:#8b8d8f}.stack-report .error-msg .container-progress{width:50%;margin:0 auto}.stack-report .accordion-custom{cursor:pointer}.stack-report .card.accordion-custom .card-header{background:#6fc0f9;color:#fff;cursor:pointer}.stack-report .card.accordion-custom .card-header .accordion-heading{float:left}.stack-report .card.accordion-custom .card-header .accordion-sub-heading{float:right;color:#030303}.stack-report .card.accordion-custom .card-header:after{content:'';clear:both;float:none;display:block}.stack-report .error-wrapper{position:relative;height:80%;width:50%;margin:5% auto}.stack-report .error-wrapper .error-image .display-icon{font-size:10vw}.stack-report .error-wrapper .error-image .not-found-class{color:#ff1f1c}.stack-report .error-wrapper .error-image .warning-class{color:#fb8c00}.stack-report .error-wrapper .error-image .progress-class{color:#3b5998}.stack-report .error-wrapper .error-container{position:relative}"]
                }] }
    ];
    /** @nocollapse */
    StackDetailsComponent.ctorParameters = function () { return [
        { type: StackAnalysesService },
        { type: CommonService }
    ]; };
    StackDetailsComponent.propDecorators = {
        gatewayConfig: [{ type: Input }],
        stack: [{ type: Input }],
        displayName: [{ type: Input }],
        repoInfo: [{ type: Input }],
        buildNumber: [{ type: Input }],
        appName: [{ type: Input }],
        stackResponse: [{ type: Input }],
        showFlags: [{ type: Input }],
        openStackModalFromCard: [{ type: Input }],
        modalStackModule: [{ type: ViewChild, args: ['stackModule',] }]
    };
    return StackDetailsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PipelineInsightsService = /** @class */ (function () {
    function PipelineInsightsService(http, auth) {
        this.http = http;
        this.auth = auth;
        this.headers = new HttpHeaders({ 'Content-Type': 'application/json' });
        if (this.auth && this.auth.getToken && this.auth.getToken() !== null) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + this.auth.getToken());
        }
    }
    /**
     * @param {?} url
     * @param {?=} params
     * @return {?}
     */
    PipelineInsightsService.prototype.getStackAnalyses = /**
     * @param {?} url
     * @param {?=} params
     * @return {?}
     */
    function (url, params) {
        /** @type {?} */
        var options = { headers: this.headers, observe: 'response' };
        if (params && params['access_token']) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + params['access_token']);
        }
        return this.http.get(url, options)
            .pipe(map(this.extractData), catchError(this.handleError));
    };
    /**
     * @private
     * @param {?} res
     * @return {?}
     */
    PipelineInsightsService.prototype.extractData = /**
     * @private
     * @param {?} res
     * @return {?}
     */
    function (res) {
        /** @type {?} */
        var body = res.body || (/** @type {?} */ ({}));
        body['statusCode'] = res.status;
        body['statusText'] = res.statusText;
        return body;
    };
    /**
     * @private
     * @param {?} error
     * @return {?}
     */
    PipelineInsightsService.prototype.handleError = /**
     * @private
     * @param {?} error
     * @return {?}
     */
    function (error) {
        /** @type {?} */
        var body = {};
        if (error.error instanceof ErrorEvent) {
            body = {
                statusText: error.error.message || error.error.toString()
            };
        }
        else if (error.status && error.statusText) {
            body = {
                status: error.status,
                statusText: error.statusText
            };
        }
        return throwError(body);
    };
    PipelineInsightsService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    PipelineInsightsService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: AuthenticationService }
    ]; };
    return PipelineInsightsService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PipelineInsightsComponent = /** @class */ (function () {
    function PipelineInsightsComponent(pipelineInsightsService) {
        this.pipelineInsightsService = pipelineInsightsService;
        this.onStackResponse = new EventEmitter();
        this.flag = false;
        this.flag1 = false;
        this.interval = 7000;
    }
    /**
     * @return {?}
     */
    PipelineInsightsComponent.prototype.geturl = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var subs = null;
        /** @type {?} */
        var alive = true;
        /** @type {?} */
        var counter = 0;
        if (this.url && this.url !== '') {
            if (this.stackUrl === this.url) {
                return;
            }
            this.stackUrl = this.url;
            /** @type {?} */
            var observable_1 = this.pipelineInsightsService
                .getStackAnalyses(this.url);
            timer(0, this.interval)
                .pipe(takeWhile(function () { return alive; }), catchError(function (error) { return of("error: " + error); }))
                .subscribe(function () {
                if (subs) {
                    subs.unsubscribe();
                }
                subs = observable_1.subscribe(function (data) {
                    if (data && (!data.hasOwnProperty('error') && Object.keys(data).length !== 0) && (data.statusCode === 200 || data.statusCode === 202)) {
                        alive = false;
                        subs.unsubscribe();
                        /** @type {?} */
                        var response = data.result;
                        if (response.length > 0) {
                            for (var i = 0; i < data.result.length; ++i) {
                                /** @type {?} */
                                var c = data.result[i];
                                if (c.user_stack_info) {
                                    if (c.user_stack_info.analyzed_dependencies) {
                                        for (var j = 0; j < c.user_stack_info.analyzed_dependencies.length; ++j) {
                                            /** @type {?} */
                                            var d = c.user_stack_info.analyzed_dependencies[j];
                                            if (d.security && d.security.length > 0) {
                                                _this.flag = true;
                                                break;
                                            }
                                        }
                                    }
                                }
                            }
                            for (var i = 0; i < data.result.length; ++i) {
                                /** @type {?} */
                                var c = data.result[i];
                                if (c.user_stack_info) {
                                    if (c.user_stack_info.license_analysis) {
                                        /** @type {?} */
                                        var d = c.user_stack_info.license_analysis.status;
                                        if (d === 'ComponentConflict') {
                                            _this.flag1 = true;
                                            break;
                                        }
                                        if (d === 'StackConflict') {
                                            _this.flag1 = true;
                                            break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    if (data.statusCode !== 200 && data.statusCode !== 202) {
                        alive = false;
                        subs.unsubscribe();
                        _this.onStackResponse.emit(data);
                    }
                }, function (error) {
                    alive = false;
                });
                if (counter++ > 3) {
                    alive = false;
                }
            });
        }
    };
    /**
     * @return {?}
     */
    PipelineInsightsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.geturl();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    PipelineInsightsComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        if (changes && changes['url'] && changes['url']['currentValue'] !== changes['url']['previousValue']) {
            this.geturl();
        }
    };
    PipelineInsightsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'pipleine-insights-details',
                    template: "<div class=\"pipeline-insights\">\n  <div class=\"imp \" *ngIf=\"flag && flag1; else elseBlock\">\n    <div class=\"imp_info row warning-style\">\n      <span class=\"pficon-warning-triangle-o\" data-toggle=\"tooltip\"\n        title=\"CVE Issue\">\n      </span>\n      <span>\n        <b>CVE's</b> and\n        <b>License Issue(s)</b> are present\n      </span>\n    </div>\n  </div>\n  <ng-template #elseBlock>\n    <div class=\"imp\">\n      <div class=\"imp_info row warning-style\" *ngIf=\"flag\" >\n        <span class=\"pficon-warning-triangle-o\" data-toggle=\"tooltip\"\n          title=\"CVE Issue\">\n        </span>\n        <span>\n          <b>CVE's</b> are present</span>\n      </div>\n      <div class=\"imp_info row\" *ngIf=\"flag1\">\n        <span class=\"pficon-warning-triangle-o col warning-style\" data-toggle=\"tooltip\"\n          title=\"License Issue\">\n        </span>\n        <span>\n          <b>License</b> Issue are present.</span>\n      </div>\n    </div>\n  </ng-template>\n</div>",
                    styles: [".pipeline-insights{align-content:center;cursor:pointer}.pipeline-insights .pipeline-insights-btn{cursor:pointer}.pipeline-insights .warning-style{padding-right:2px;color:#c00;font-size:12px}.pipeline-insights .imp{font-size:12px;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content}.pipeline-insights .imp .imp_info{padding:5px 3px 5px 5px}.pipeline-insights .imp .imp_info .pficon-warning-triangle-o:before{color:#c00}"]
                }] },
        { type: Injectable }
    ];
    /** @nocollapse */
    PipelineInsightsComponent.ctorParameters = function () { return [
        { type: PipelineInsightsService }
    ]; };
    PipelineInsightsComponent.propDecorators = {
        stack: [{ type: Input }],
        buildNumber: [{ type: Input }],
        appName: [{ type: Input }],
        stackResponse: [{ type: Input }],
        component: [{ type: Input }],
        url: [{ type: Input }],
        onStackResponse: [{ type: Output }],
        modalStackModule: [{ type: ViewChild, args: ['stackModule',] }]
    };
    return PipelineInsightsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PipelineInsightsModule = /** @class */ (function () {
    function PipelineInsightsModule() {
    }
    PipelineInsightsModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        HttpClientModule
                    ],
                    declarations: [
                        PipelineInsightsComponent
                    ],
                    exports: [
                        PipelineInsightsComponent
                    ],
                    providers: [GlobalConstants, PipelineInsightsService],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    /** @nocollapse */
    PipelineInsightsModule.ctorParameters = function () { return []; };
    return PipelineInsightsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryTitleComponent = /** @class */ (function () {
    function ReportSummaryTitleComponent() {
    }
    ReportSummaryTitleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'analytics-summary-title',
                    template: "<div class=\"analytics-summary-title\">\n    <div class=\"card-pf-title\">\n        <span [class]=\"title?.titleIcon\" aria-hidden=\"true\"></span>\n        {{title?.titleText}}\n    </div>\n    <span [ngStyle]=\"{'background-color': title?.notificationIconBgColor}\" class=\"ana-notification-icon pull-right\" *ngIf=\"title?.notificationIcon\">\n        <i [class]=\"title?.notificationIcon\" aria-hidden=\"true\"></i>\n    </span>\n</div>\n",
                    styles: [".analytics-summary-title{position:relative}.analytics-summary-title .card-pf-title{margin:0;font-weight:600;font-size:18px;color:#333}.analytics-summary-title .card-pf-title span:first-child{margin-right:5px;display:inline-block}.analytics-summary-title .ana-notification-icon{position:absolute;right:-20px;top:-12px;padding:10px;color:#fff}.analytics-summary-title .ana-notification-icon i:before{color:#fff}"]
                }] }
    ];
    ReportSummaryTitleComponent.propDecorators = {
        title: [{ type: Input }]
    };
    return ReportSummaryTitleComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Vendor imports Go HERE
 */
var ReportSummaryDescriptionComponent = /** @class */ (function () {
    function ReportSummaryDescriptionComponent() {
    }
    ReportSummaryDescriptionComponent.decorators = [
        { type: Component, args: [{
                    selector: 'analytics-summary-description',
                    template: "<p [innerText]=\"description\"></p>\n",
                    styles: ["p{margin:10px 0;font-size:12px;color:#333}"]
                }] }
    ];
    ReportSummaryDescriptionComponent.propDecorators = {
        description: [{ type: Input }]
    };
    return ReportSummaryDescriptionComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressMeterComponent = /** @class */ (function () {
    function ProgressMeterComponent() {
    }
    ProgressMeterComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ana-progress-meter',
                    template: "<div class=\"ana-progress-meter\">\n    <span *ngIf=\"config?.headerText\" class=\"content-desc\" [innerText]=\"config?.headerText && config?.headerText\"></span>\n    <div class=\"ana-progress-bar\" *ngIf=\"config?.value\">\n        <div class=\"progress-meter\" [ngStyle]=\"{'background-color': config?.bgColor, 'width': config?.width + '%'}\"></div>\n    </div>\n    <span *ngIf=\"config?.footerText\" class=\"footer-desc\" [innerText]=\"config?.footerText\"></span>\n</div>\n",
                    styles: [".ana-progress-meter .content-desc{font-size:12px;display:inline-block}.ana-progress-meter .ana-progress-bar{width:70%;position:relative;background:#ededed;height:15px}.ana-progress-meter .ana-progress-bar .progress-meter{height:100%}.ana-progress-meter .footer-desc{margin-top:10px;font-size:12px}"]
                }] }
    ];
    ProgressMeterComponent.propDecorators = {
        config: [{ type: Input }]
    };
    return ProgressMeterComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ProgressMeterModule = /** @class */ (function () {
    function ProgressMeterModule() {
    }
    ProgressMeterModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [
                        ProgressMeterComponent
                    ],
                    exports: [
                        ProgressMeterComponent
                    ]
                },] }
    ];
    return ProgressMeterModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryInfoEntriesComponent = /** @class */ (function () {
    function ReportSummaryInfoEntriesComponent() {
    }
    ReportSummaryInfoEntriesComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ana-summary-info',
                    template: "<div class=\"ana-summary-info\">\n    <div *ngIf=\"entry?.infoType === 'text'\" class=\"ana-normal\">\n        <div class=\"row\">\n            <div class=\"col-sm-8 info-key\" [innerText]=\"entry?.infoText\"></div>\n            <div class=\"col-sm-4 info-value\" [innerText]=\"entry?.infoValue\"></div>\n        </div>\n    </div>\n    <div class=\"ana-custom\" [ngSwitch]=\"entry?.infoType\">\n        <!-- should handle for various infoTypes -->\n        <div *ngSwitchCase=\"'progress'\">\n            <span class=\"info-key\" [innerText]=\"entry?.infoText\"></span>\n            <span class=\"info-value\">\n                <ana-progress-meter [config]=\"entry?.config\"></ana-progress-meter>\n            </span>\n        </div>\n    </div>\n</div>\n",
                    styles: [".ana-summary-info{font-size:15px;font-weight:100}.ana-summary-info .ana-normal .info-key{padding:0 10px}.ana-summary-info .ana-normal .info-value{color:#2a9fd8;font-weight:500;padding:0 10px;text-align:right}.ana-summary-info .ana-normal:after{content:'';display:block;float:none;clear:both}.ana-summary-info .ana-custom .info-key,.ana-summary-info .ana-custom .info-value{display:block}"]
                }] }
    ];
    ReportSummaryInfoEntriesComponent.propDecorators = {
        entry: [{ type: Input }]
    };
    return ReportSummaryInfoEntriesComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryContentComponent = /** @class */ (function () {
    function ReportSummaryContentComponent() {
    }
    ReportSummaryContentComponent.decorators = [
        { type: Component, args: [{
                    selector: 'analytics-summary-content',
                    template: "<div class=\"analytics-summary-content\">\n    <div *ngIf=\"content?.infoEntries\" class=\"ana-summary-metric\">\n        <ana-summary-info *ngFor=\"let entry of content?.infoEntries\" [entry]=\"entry\" ></ana-summary-info>\n    </div>\n    <div *ngIf=\"content?.infoEntries?.length === 0 && cardType === 'security'\" class=\"no-security-message\">\n        No securities issues found.\n    </div>\n</div>\n",
                    styles: [".analytics-summary-content{margin:10px}.analytics-summary-content .no-security-message{font-size:15px;font-weight:100;margin-left:-10px}"]
                }] }
    ];
    ReportSummaryContentComponent.propDecorators = {
        content: [{ type: Input }],
        cardType: [{ type: Input }]
    };
    return ReportSummaryContentComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var dependencies = [
    ReportSummaryInfoEntriesComponent
];
/** @type {?} */
var imports = [
    ProgressMeterModule
];
var ReportSummaryContentModule = /** @class */ (function () {
    function ReportSummaryContentModule() {
    }
    ReportSummaryContentModule.decorators = [
        { type: NgModule, args: [{
                    imports: __spread([
                        CommonModule
                    ], imports),
                    declarations: __spread(dependencies, [
                        ReportSummaryContentComponent
                    ]),
                    exports: [
                        ReportSummaryContentComponent
                    ]
                },] }
    ];
    return ReportSummaryContentModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryCardComponent = /** @class */ (function () {
    function ReportSummaryCardComponent() {
    }
    /**
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.paintView();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['card'];
        if (summary) {
            this.card = (/** @type {?} */ (summary.currentValue));
            this.repaintView();
        }
    };
    /**
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        if (this.isFromShortReport !== 'true' && SaveState.ELEMENTS[0]) {
            SaveState.ELEMENTS[0].click();
        }
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.updateCard = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.card) {
            this.reportSummaryTitle = this.card.reportSummaryTitle;
            if (this.isFromShortReport === 'true') {
                this.reportSummaryDescription = this.card.reportSummaryDescriptionShort;
            }
            else {
                this.reportSummaryDescription = this.card.reportSummaryDescription;
            }
            this.reportSummaryContent = this.card.reportSummaryContent;
            this.identifier = this.card.identifier;
        }
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.paintView = /**
     * @private
     * @return {?}
     */
    function () {
        this.updateCard();
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryCardComponent.prototype.repaintView = /**
     * @private
     * @return {?}
     */
    function () {
        this.paintView();
    };
    ReportSummaryCardComponent.decorators = [
        { type: Component, args: [{
                    selector: 'analytics-summary-card',
                    template: "<div summaryCardClick *ngIf=\"isFromShortReport !== 'true'\" class=\"analytics-summary-card\">\n    <div class=\"card-pf\">\n        <analytics-summary-title [title]=\"reportSummaryTitle\"></analytics-summary-title>\n        <analytics-summary-description [description]=\"reportSummaryDescription\"></analytics-summary-description>\n        <analytics-summary-content [cardType]=\"identifier\" [content]=\"reportSummaryContent\"></analytics-summary-content>\n    </div>\n</div>\n<div *ngIf=\"isFromShortReport === 'true'\" class=\"analytics-summary-card\">\n        <div class=\"card-pf\">\n            <analytics-summary-title [title]=\"reportSummaryTitle\"></analytics-summary-title>\n            <analytics-summary-description [description]=\"reportSummaryDescription\"></analytics-summary-description>\n            <analytics-summary-content [cardType]=\"identifier\" [content]=\"reportSummaryContent\"></analytics-summary-content>\n        </div>\n    </div>\n",
                    styles: [".analytics-summary-card{cursor:pointer;display:-webkit-flexbox;display:flex;align-items:stretch}.analytics-summary-card .card-pf{padding:10px 20px}.analytics-summary-card.highlight .card-pf{border-bottom:4px solid #39a5dc;box-shadow:0 0 15px #777}.analytics-summary-card.highlight .card-pf:after{content:'';width:30px;height:30px;display:block;position:absolute;border:2px solid #39a5dc;bottom:-15px;left:45%;-webkit-transform:rotate(45deg);transform:rotate(45deg);border-bottom:0;border-right:0;background:#fff;z-index:9}"]
                }] }
    ];
    ReportSummaryCardComponent.propDecorators = {
        card: [{ type: Input }],
        isFromShortReport: [{ type: Input }]
    };
    return ReportSummaryCardComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryCardDirective = /** @class */ (function () {
    function ReportSummaryCardDirective(elementRef) {
        this.elementRef = elementRef;
        this.stack = [];
        this.HIGHLIGHT = 'highlight';
        this.element = elementRef.nativeElement;
        SaveState.ELEMENTS.push(this.element);
    }
    /**
     * @return {?}
     */
    ReportSummaryCardDirective.prototype.onCardClick = /**
     * @return {?}
     */
    function () {
        this.removeAllOtherActives(this.element);
        this.element.classList.add(this.HIGHLIGHT);
    };
    /**
     * @private
     * @param {?} element
     * @return {?}
     */
    ReportSummaryCardDirective.prototype.removeAllOtherActives = /**
     * @private
     * @param {?} element
     * @return {?}
     */
    function (element) {
        var _this = this;
        if (SaveState && SaveState.ELEMENTS.length > 0) {
            SaveState.ELEMENTS.forEach(function (elem) {
                if (elem !== element) {
                    if (elem && elem.classList && elem.classList.contains(_this.HIGHLIGHT)) {
                        elem.classList.remove(_this.HIGHLIGHT);
                    }
                }
            });
        }
    };
    ReportSummaryCardDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[summaryCardClick]'
                },] }
    ];
    /** @nocollapse */
    ReportSummaryCardDirective.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    ReportSummaryCardDirective.propDecorators = {
        onCardClick: [{ type: HostListener, args: ['click',] }]
    };
    return ReportSummaryCardDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var dependencies$1 = [
    ReportSummaryTitleComponent,
    ReportSummaryDescriptionComponent,
    ReportSummaryCardComponent,
    ReportSummaryCardDirective
];
/** @type {?} */
var imports$1 = [
    ReportSummaryContentModule
];
var ReportSummaryCardModule = /** @class */ (function () {
    function ReportSummaryCardModule() {
    }
    ReportSummaryCardModule.decorators = [
        { type: NgModule, args: [{
                    imports: __spread([
                        CommonModule
                    ], imports$1),
                    declarations: __spread(dependencies$1),
                    exports: [
                        ReportSummaryCardComponent
                    ]
                },] }
    ];
    return ReportSummaryCardModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StackReportModel = /** @class */ (function () {
    function StackReportModel() {
    }
    return StackReportModel;
}());
var ResultInformationModel = /** @class */ (function () {
    function ResultInformationModel() {
    }
    return ResultInformationModel;
}());
var AuditInformationModel = /** @class */ (function () {
    function AuditInformationModel() {
    }
    return AuditInformationModel;
}());
var RecommendationsModel = /** @class */ (function () {
    function RecommendationsModel() {
    }
    return RecommendationsModel;
}());
var ComponentInformationModel = /** @class */ (function () {
    function ComponentInformationModel() {
    }
    return ComponentInformationModel;
}());
var GithubModel = /** @class */ (function () {
    function GithubModel() {
    }
    return GithubModel;
}());
var SentimentModel = /** @class */ (function () {
    function SentimentModel() {
    }
    return SentimentModel;
}());
var OutlierInformationModel = /** @class */ (function () {
    function OutlierInformationModel() {
    }
    return OutlierInformationModel;
}());
var UserStackInfoModel = /** @class */ (function () {
    function UserStackInfoModel() {
    }
    return UserStackInfoModel;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryComponent = /** @class */ (function () {
    function ReportSummaryComponent() {
        var _a;
        this.onCardClick = new EventEmitter();
        this.reportSummaryCards = [];
        this.reportSummaryCardsForShort = [];
        this.notification = null;
        this.cardTypes = {
            SECURITY: 'security',
            INSIGHTS: 'insights',
            LICENSES: 'licenses',
            COMP_DETAILS: 'compDetails'
        };
        this.titleAndDescription = (_a = {},
            _a[this.cardTypes.SECURITY] = {
                title: 'Dependencies with security issues in your stack',
                description: 'OSIO Analytics identifies security issues in your stack. Click this card to see further details of the security tasks affecting your stack.'
            },
            _a[this.cardTypes.INSIGHTS] = {
                title: 'Insights on alternate or additional dependencies that can augment your stack',
                description: 'OSIO Analytics identifies dependencies that are rarely used in similar stacks, and suggests alternate and additional dependencies that can enhance your stack. Click this card to see detailed suggestions on alternate and additional dependencies.'
            },
            _a[this.cardTypes.LICENSES] = {
                title: 'License details of dependencies in your stack',
                description: 'OSIO Analytics identifies the stack level license, the conflicting licenses, and the unknown licenses for your stack. Click this card to see detailed information on the conflicting and unknown licenses in your stack.'
            },
            _a[this.cardTypes.COMP_DETAILS] = {
                title: 'Dependency details of your manifest file',
                description: 'Dependencies analyzed based on versions and popularity. Click this card to see security, license and usage information for each dependency.'
            },
            _a);
        this.reportSummaryUtils = new ReportSummaryUtils();
        this.notification = this.reportSummaryUtils.notification;
    }
    /**
     * @return {?}
     */
    ReportSummaryComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.paintView();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ReportSummaryComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['report'];
        if (summary) {
            this.report = (/** @type {?} */ (summary.currentValue));
            this.repaintView();
        }
    };
    /**
     * @param {?} card
     * @return {?}
     */
    ReportSummaryComponent.prototype.handleSummaryClick = /**
     * @param {?} card
     * @return {?}
     */
    function (card) {
        if (card) {
            /** @type {?} */
            var cardType = card.identifier || '';
            this.onCardClick.emit({
                cardType: cardType,
                report: this.report,
                isFromShortReport: this.isFromShortReport
            });
        }
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.newCardInstance = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var newCard = new MReportSummaryCard();
        newCard.reportSummaryContent = new MReportSummaryContent();
        newCard.reportSummaryTitle = new MReportSummaryTitle();
        return newCard;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    ReportSummaryComponent.prototype.getComponentSecurityInformation = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        if (component) {
            /** @type {?} */
            var securityDetails = new MSecurityDetails();
            /** @type {?} */
            var securityIssues = 0;
            /** @type {?} */
            var maxIssue = null;
            /** @type {?} */
            var temp = null;
            if (component.security && component.security.length > 0) {
                /** @type {?} */
                var currSecurity = component.security;
                temp = currSecurity.reduce(function (a, b) {
                    return parseFloat(a.CVSS) < parseFloat(b.CVSS) ? b : a;
                });
                if (temp) {
                    if (maxIssue === null || maxIssue.CVSS < temp.CVSS) {
                        maxIssue = temp;
                    }
                }
                securityIssues += currSecurity.length;
            }
            if (maxIssue) {
                securityDetails.highestIssue = new MSecurityIssue(maxIssue.CVSS, maxIssue.CVE);
                securityDetails.progressReport = new MProgressMeter('', Number(maxIssue.CVSS), Number(maxIssue.CVSS) >= 7 ? '#ff6162' : 'ORANGE', '', Number(maxIssue.CVSS) * 10);
            }
            securityDetails.totalIssues = securityIssues;
            return securityDetails;
        }
        return null;
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.getSecurityReportCard = /**
     * @private
     * @return {?}
     */
    function () {
        return this.reportSummaryUtils.getSecurityReportCard(this.report.user_stack_info);
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.getInsightsReportCard = /**
     * @private
     * @return {?}
     */
    function () {
        return this.reportSummaryUtils.getInsightsReportCard(this.report.recommendation);
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.getLicensesReportCard = /**
     * @private
     * @return {?}
     */
    function () {
        return this.reportSummaryUtils.getLicensesReportCard(this.report.user_stack_info);
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.getComponentDetailsReportCard = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var componentDetailsCard = this.reportSummaryUtils.newCardInstance();
        componentDetailsCard.identifier = this.cardTypes.COMP_DETAILS;
        componentDetailsCard.reportSummaryTitle.titleIcon = 'fa fa-cube';
        componentDetailsCard.reportSummaryTitle.titleText = 'Dependency Details';
        componentDetailsCard.reportSummaryDescription = this.titleAndDescription[this.cardTypes.COMP_DETAILS].description;
        componentDetailsCard.reportSummaryContent.infoEntries = [];
        if (this.report.user_stack_info &&
            this.report.user_stack_info) {
            /** @type {?} */
            var userStackInfo = this.report.user_stack_info;
            /** @type {?} */
            var analyzedCount = void 0;
            /** @type {?} */
            var totalCount = void 0;
            /** @type {?} */
            var unknownCount = void 0;
            analyzedCount = userStackInfo.analyzed_dependencies ? userStackInfo.analyzed_dependencies.length : 0;
            totalCount = userStackInfo.dependencies ? userStackInfo.dependencies.length : 0;
            unknownCount = userStackInfo.unknown_dependencies ? userStackInfo.unknown_dependencies.length : totalCount - analyzedCount;
            /** @type {?} */
            var totalEntry = new MReportSummaryInfoEntry();
            totalEntry.infoText = 'Total Dependencies';
            totalEntry.infoValue = totalCount;
            /** @type {?} */
            var analyzedEntry = new MReportSummaryInfoEntry();
            analyzedEntry.infoText = 'Analyzed Dependencies';
            analyzedEntry.infoValue = analyzedCount;
            /** @type {?} */
            var unknownEntry = new MReportSummaryInfoEntry();
            unknownEntry.infoText = 'Unknown Dependencies';
            unknownEntry.infoValue = unknownCount;
            componentDetailsCard.reportSummaryContent.infoEntries.push(totalEntry);
            componentDetailsCard.reportSummaryContent.infoEntries.push(analyzedEntry);
            componentDetailsCard.reportSummaryContent.infoEntries.push(unknownEntry);
        }
        return componentDetailsCard;
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.updateCards = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var cards = [];
        if (this.report) {
            cards[0] = this.getSecurityReportCard();
            cards[1] = this.getLicensesReportCard();
            cards[2] = this.getInsightsReportCard();
            cards[3] = this.getComponentDetailsReportCard();
        }
        this.reportSummaryCards = cards;
        this.reportSummaryCardsForShort = cards.slice(0, 3);
        // Select the first card by default
        if (this.isFromShortReport !== 'true') {
            this.handleSummaryClick(cards[0]);
        }
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.paintView = /**
     * @private
     * @return {?}
     */
    function () {
        this.updateCards();
    };
    /**
     * @private
     * @return {?}
     */
    ReportSummaryComponent.prototype.repaintView = /**
     * @private
     * @return {?}
     */
    function () {
        this.paintView();
    };
    ReportSummaryComponent.decorators = [
        { type: Component, args: [{
                    selector: 'analytics-report-summary',
                    template: "<div class=\"analytics-summary-report\" *ngIf=\"isFromShortReport !== 'true'\">\n    <analytics-summary-card (click)=\"handleSummaryClick(card)\" class=\"col-md-3\" *ngFor=\"let card of reportSummaryCards\" [card]=\"card\"></analytics-summary-card>\n</div>\n<div class=\"analytics-summary-report short-report\" *ngIf=\"isFromShortReport === 'true'\">\n    <analytics-summary-card (click)=\"handleSummaryClick(card)\" class=\"col-md-4\" [card]=\"card\" *ngFor=\"let card of reportSummaryCardsForShort\" [isFromShortReport]=\"isFromShortReport\"></analytics-summary-card>\n</div>\n",
                    styles: [".analytics-summary-report{background:#f5f5f5;padding:20px 10px 0;display:-webkit-flexbox;display:flex;align-items:stretch}.analytics-summary-report:after{content:'';display:block;float:none;clear:both}.analytics-summary-report analytics-summary-card{display:-webkit-flexbox;display:flex;align-items:stretch}.analytics-summary-report.short-report{background:0 0;padding:0}"]
                }] }
    ];
    /** @nocollapse */
    ReportSummaryComponent.ctorParameters = function () { return []; };
    ReportSummaryComponent.propDecorators = {
        report: [{ type: Input }],
        onCardClick: [{ type: Output, args: ['onCardClick',] }],
        isFromShortReport: [{ type: Input }]
    };
    return ReportSummaryComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportSummaryModule = /** @class */ (function () {
    function ReportSummaryModule() {
    }
    ReportSummaryModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        ReportSummaryCardModule
                    ],
                    declarations: [
                        ReportSummaryComponent
                    ],
                    exports: [
                        ReportSummaryComponent
                    ]
                },] }
    ];
    return ReportSummaryModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentFeedbackService = /** @class */ (function () {
    function ComponentFeedbackService(http, auth) {
        this.http = http;
        this.auth = auth;
        this.headers = new HttpHeaders({ 'Content-Type': 'application/json' });
        this.FEEDBACK_URL = '';
        if (this.auth && this.auth.getToken && this.auth.getToken() !== null) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + this.auth.getToken());
        }
    }
    /**
     * @param {?} feedback
     * @return {?}
     */
    ComponentFeedbackService.prototype.postFeedback = /**
     * @param {?} feedback
     * @return {?}
     */
    function (feedback) {
        /** @type {?} */
        var options = { headers: this.headers, observe: 'response' };
        /** @type {?} */
        var body = JSON.stringify(feedback.feedbackTemplate);
        this.FEEDBACK_URL = feedback.baseUrl + 'api/v1/submit-feedback';
        return this.http.post(this.FEEDBACK_URL, body, options)
            .pipe(map(this.extractData), catchError(this.handleError));
    };
    /**
     * @private
     * @param {?} res
     * @return {?}
     */
    ComponentFeedbackService.prototype.extractData = /**
     * @private
     * @param {?} res
     * @return {?}
     */
    function (res) {
        /** @type {?} */
        var body = res.body || {};
        body['statusCode'] = res.status;
        body['statusText'] = res.statusText;
        return body;
    };
    /**
     * @private
     * @param {?} error
     * @return {?}
     */
    ComponentFeedbackService.prototype.handleError = /**
     * @private
     * @param {?} error
     * @return {?}
     */
    function (error) {
        /** @type {?} */
        var body = {};
        if (error.error instanceof ErrorEvent) {
            body = {
                statusText: error.error.message || error.error.toString()
            };
        }
        else if (error.status && error.statusText) {
            body = {
                status: error.status,
                statusText: error.statusText
            };
        }
        return throwError(body);
    };
    ComponentFeedbackService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    ComponentFeedbackService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: AuthenticationService }
    ]; };
    return ComponentFeedbackService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentFeedbackComponent = /** @class */ (function () {
    function ComponentFeedbackComponent(feedbackService) {
        this.feedbackService = feedbackService;
        this.feedbackMessages = [];
        this.feedbackColorTypeUp = false;
        this.feedbackColorTypeDown = false;
    }
    /**
     * @param {?} event
     * @param {?} type
     * @param {?} colorType
     * @return {?}
     */
    ComponentFeedbackComponent.prototype.handleFeedback = /**
     * @param {?} event
     * @param {?} type
     * @param {?} colorType
     * @return {?}
     */
    function (event, type, colorType) {
        var _this = this;
        event.stopPropagation();
        if (this.feedback && this.feedback.feedbackTemplate) {
            this.feedback.feedbackTemplate.feedback_type = type;
            /** @type {?} */
            var subscription = this.feedbackService.postFeedback(this.feedback);
            if (subscription) {
                subscription.subscribe(function (result) {
                    _this.feedbackMessages.push({
                        text: 'Feedback successfully submitted',
                        iconClass: 'pficon-ok'
                    });
                });
            }
        }
        if (type) {
            if (colorType) {
                this.feedbackColorTypeDown = false;
            }
        }
        else {
            if (colorType) {
                this.feedbackColorTypeUp = false;
            }
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ComponentFeedbackComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['feedback'];
        if (summary) {
            this.feedback = (/** @type {?} */ (summary.currentValue));
        }
    };
    ComponentFeedbackComponent.decorators = [
        { type: Component, args: [{
                    selector: 'component-feedback',
                    template: "<!-- <fab-toast-notification [notifications]=\"feedbackMessages\"></fab-toast-notification> -->\n<div class=\"analytics-component-feedback\">\n    <div *ngIf=\"feedback?.feedbackTemplate\" class=\"feedback\">\n        <span (click)=\"feedbackColorTypeUp=!feedbackColorTypeUp;handleFeedback($event, true, feedbackColorTypeUp);\" [ngClass]=\"{'thumbs-up': !feedbackColorTypeUp , 'thumbs-up-true': feedbackColorTypeUp}\"\n            aria-label=\"positive feedback\">\n            <i [ngClass]=\"{'fa': true,'fa-thumbs-o-up': !feedbackColorTypeUp , 'fa-thumbs-up': feedbackColorTypeUp}\" aria-hidden=\"true\"></i>\n        </span>\n        <span (click)=\"feedbackColorTypeDown=!feedbackColorTypeDown;handleFeedback($event, false, feedbackColorTypeDown);\" [ngClass]=\"{'thumbs-down': !feedbackColorTypeDown , 'thumbs-down-true': feedbackColorTypeDown}\"\n            aria-label=\"negative feedback\">\n            <i [ngClass]=\"{'fa': true,'fa-thumbs-o-down': !feedbackColorTypeDown , 'fa-thumbs-down': feedbackColorTypeDown}\" aria-hidden=\"true\"></i>\n        </span>\n    </div>\n    <span class=\"no-feedback\" *ngIf=\"!feedback?.feedbackTemplate\">-----</span>\n</div>\n",
                    styles: [".analytics-component-feedback span{cursor:pointer;font-size:25px;margin-right:10px}.analytics-component-feedback .thumbs-up{color:#363636}.analytics-component-feedback .thumbs-up-true,.analytics-component-feedback .thumbs-up:active,.analytics-component-feedback .thumbs-up:hover{color:#6ec664}.analytics-component-feedback .thumbs-down{color:#363636}.analytics-component-feedback .thumbs-down-true,.analytics-component-feedback .thumbs-down:active,.analytics-component-feedback .thumbs-down:hover{color:#c00}.analytics-component-feedback .no-feedback{font-size:unset}"]
                }] }
    ];
    /** @nocollapse */
    ComponentFeedbackComponent.ctorParameters = function () { return [
        { type: ComponentFeedbackService }
    ]; };
    ComponentFeedbackComponent.propDecorators = {
        feedback: [{ type: Input }]
    };
    return ComponentFeedbackComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ToastNotificationComponent = /** @class */ (function () {
    function ToastNotificationComponent() {
    }
    /**
     * @param {?} notification
     * @return {?}
     */
    ToastNotificationComponent.prototype.closeToastNotification = /**
     * @param {?} notification
     * @return {?}
     */
    function (notification) {
        this.notifications.splice(this.notifications.indexOf(notification), 1);
    };
    ToastNotificationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'fab-toast-notification',
                    template: "<!-- Toast notification HTML -->\n<div class=\"toast-notification-container\">\n  <div *ngFor=\"let notification of notifications\" class=\"toast-pf alert {{notification.alertClass}} alert-dismissable toast-notification-wrapper\">\n    <button type=\"button\" class=\"close\" data-dismiss=\"alert\" aria-hidden=\"true\" (click)=\"closeToastNotification(notification)\">\n      <span class=\"pficon pficon-close\"></span>\n    </button>\n    <span class=\"pficon {{notification.iconClass}}\"></span>\n    <div class=\"toast-wrapper\">\n      <span>{{notification.text}}</span>\n      <a *ngIf=\"notification.link\" target=\"_blank\" href=\"{{notification.link}}\">{{notification.linkText}}</a>\n    </div>\n  </div>\n</div>\n<!-- Toast notification end HTML -->\n",
                    styles: [".toast-notification-container{position:fixed;top:36px;right:50px;z-index:10;width:630px}.toast-notification-container .toast-notification-wrapper{width:100%}.toast-notification-container .toast-notification-wrapper .toast-wrapper{padding-left:10px}.toast-notification-container .toast-notification-wrapper .toast-wrapper a{margin-left:20px}.toast-notification-container span.pficon{left:0;top:0}"]
                }] }
    ];
    ToastNotificationComponent.propDecorators = {
        notifications: [{ type: Input }]
    };
    return ToastNotificationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var declarations = [
    ToastNotificationComponent
];
var ToastNotificationModule = /** @class */ (function () {
    function ToastNotificationModule() {
    }
    ToastNotificationModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: __spread(declarations),
                    exports: __spread(declarations)
                },] }
    ];
    return ToastNotificationModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentFeedbackModule = /** @class */ (function () {
    function ComponentFeedbackModule() {
    }
    ComponentFeedbackModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        ToastNotificationModule
                    ],
                    declarations: [
                        ComponentFeedbackComponent
                    ],
                    providers: [ComponentFeedbackService],
                    exports: [
                        ComponentFeedbackComponent
                    ]
                },] }
    ];
    return ComponentFeedbackModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentSnippetComponent = /** @class */ (function () {
    function ComponentSnippetComponent() {
        this.githubEntries = [];
        this.githubKeys = {
            contributors: 'Contributors',
            forks: 'Forks',
            depRepos: 'Dependent Repos',
            stars: 'Stars',
            usage: 'Usage'
        };
        this.osioKeys = {
            usage: 'Usage'
        };
        this.showOSIOUsage = false;
    }
    /**
     * @return {?}
     */
    ComponentSnippetComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.paint();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ComponentSnippetComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['component'];
        if (summary) {
            this.component = (/** @type {?} */ (summary.currentValue));
        }
        this.paint();
    };
    /**
     * @private
     * @return {?}
     */
    ComponentSnippetComponent.prototype.paint = /**
     * @private
     * @return {?}
     */
    function () {
        this.githubEntries = [];
        if (this.component) {
            if (this.component.github) {
                /** @type {?} */
                var github = this.component.github;
                /** @type {?} */
                var value = '';
                for (var key in github) {
                    if (key === 'users')
                        continue;
                    if (github.hasOwnProperty(key)) {
                        value = github[key];
                        value = value && value.toString() === '-1' ? 'NA' : value;
                        this.githubEntries.push({ key: this.githubKeys[key], value: value });
                    }
                }
            }
        }
    };
    ComponentSnippetComponent.decorators = [
        { type: Component, args: [{
                    selector: 'component-snippet',
                    template: "<div class=\"analytics-snippet-information\">\n    <h4>Details of the component: <span class=\"component-name\" [innerText]=\"component?.name\"></span></h4>\n    <div [ngClass]=\"{'component-version left': true, 'normal-version-box': view === 'split', 'small-version-box': view === 'normal'}\">\n        <div class=\"col-xs-6\">\n            <p class=\"info-head\">Current Version</p>\n            <p [innerText]=\"component?.currentVersion\"></p>\n        </div>\n        <div class=\"col-xs-6\">\n            <p class=\"info-head\">Latest Version</p>\n            <p [innerText]=\"component?.latestVersion\"></p>\n        </div>\n    </div>\n    <div *ngIf=\"view === 'normal'\" class=\"github-osio-box\">\n        <div class=\"github left\">\n            <div class=\"box-header\">\n                GitHub Statistics:\n            </div>\n            <div class=\"info-container left\">\n                <div *ngFor=\"let github of githubEntries\" class=\"side\">\n                    <p class=\"info-head\" [innerText]=\"github.key\"></p>\n                    <p [innerText]=\"github.value || '-----'\"></p>\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"showOSIOUsage\" class=\"osio put-bar left\">\n            <div class=\"box-header\">\n                OSIO Statistics:\n            </div>\n            <div class=\"info-container left\">\n                <div class=\"side\">\n                    <p class=\"info-head\" [innerText]=\"'OSIO Usage'\"></p>\n                    <p [innerText]=\"component?.osio?.usage || '-----'\"></p>\n                </div>\n            </div>\n        </div>\n    </div>\n    <div class=\"common-table component-licenses\">\n        <div class=\"common-wrapper\">\n            <span class=\"info-head\">License(s) used: </span>\n            <span *ngIf=\"component?.licenses?.length > 0\" class=\"common-container license-container\">\n                <span [innerText]=\"license\" *ngFor=\"let license of component?.licenses\"></span>\n            </span>\n            <span *ngIf=\"component?.licenses?.length === 0\" class=\"common-container license-container\">\n                -----\n            </span>\n        </div>\n    </div>\n    <div class=\"common-table component-tags\">\n        <div class=\"common-wrapper\">\n            <span class=\"info-head\">Tags:</span> \n            <span *ngIf=\"component?.crowdSourcing?.tags && component?.crowdSourcing?.tags?.length > 0\" class=\"common-container tags-container\">\n                <span [innerText]=\"tag\" *ngFor=\"let tag of component?.crowdSourcing?.tags\"></span>\n            </span>\n            <span *ngIf=\"!component?.crowdSourcing?.tags || component?.crowdSourcing?.tags?.length === 0\" class=\"common-container tags-container\">\n                -----\n            </span>\n        </div>\n    </div>\n    <div *ngIf=\"view === 'split'\" class=\"github-osio-box\">\n        <div class=\"github left\">\n            <div class=\"box-header\">\n                GitHub Statistics:\n            </div>\n            <div class=\"info-container left\">\n                <div *ngFor=\"let github of githubEntries\" class=\"side\">\n                    <p class=\"info-head\" [innerText]=\"github.key\"></p>\n                    <p [innerText]=\"github.value || '-----'\"></p>\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"showOSIOUsage\" class=\"osio left\">\n            <div class=\"box-header\">\n                OSIO Statistics:\n            </div>\n            <div class=\"info-container left\">\n                <div class=\"side\">\n                    <p class=\"info-head\" [innerText]=\"'OSIO Usage'\"></p>\n                    <p [innerText]=\"component?.osio?.usage || '-----'\"></p>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n",
                    styles: [".pseudo-clear{content:'';clear:both;float:none;display:block}.analytics-snippet-information{padding-top:5px}.analytics-snippet-information .component-name{font-weight:600;margin-bottom:20px}.analytics-snippet-information .component-version{background:#eff2f5;width:60%;text-align:center;min-height:90px;max-height:90px;padding:15px}.analytics-snippet-information .component-version:after{content:'';clear:both;float:none;display:block}.analytics-snippet-information .normal-version-box{width:70%}.analytics-snippet-information .small-version-box{float:left;margin-right:15px;width:35%}.analytics-snippet-information .common-table{display:table;width:100%;min-height:30px}.analytics-snippet-information .component-licenses,.analytics-snippet-information .component-tags{padding-top:10px}.analytics-snippet-information .common-wrapper{display:table-cell;vertical-align:middle}.analytics-snippet-information .common-container{margin-left:10px;font-size:13px}.analytics-snippet-information .info-head{font-weight:700;margin-bottom:10px}.analytics-snippet-information .license-container span{margin-right:3px}.analytics-snippet-information .license-container span:after{content:', '}.analytics-snippet-information .license-container span:last-child:after{content:''}.analytics-snippet-information .tags-container{margin-bottom:10px}.analytics-snippet-information .tags-container span{display:inline-block;padding:5px 20px;background:#2a9fd8;color:#fff;margin-right:5px;font-size:10px}.analytics-snippet-information .github-osio-box{background:#eff2f5;padding:10px;float:left;min-height:90px}.analytics-snippet-information .github-osio-box .box-header{float:left;margin-right:20px;font-size:13px}.analytics-snippet-information .github-osio-box .left{float:left}.analytics-snippet-information .github-osio-box .github .side{float:left;margin-right:10px}.analytics-snippet-information .github-osio-box .github:after{content:'';clear:both;float:none;display:block}.analytics-snippet-information .github-osio-box .osio.put-bar{border-left:1px solid #ccc;padding:0 0 0 10px}.analytics-snippet-information .github-osio-box .osio:after,.analytics-snippet-information .github-osio-box:after{content:'';clear:both;float:none;display:block}"]
                }] }
    ];
    ComponentSnippetComponent.propDecorators = {
        component: [{ type: Input }],
        view: [{ type: Input }]
    };
    return ComponentSnippetComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AddWorkFlowService = /** @class */ (function () {
    function AddWorkFlowService(http, apiUrl, auth, context) {
        this.http = http;
        this.apiUrl = apiUrl;
        this.auth = auth;
        this.context = context;
        this.headers = new HttpHeaders({ 'Content-Type': 'application/json' });
        this.workItemsRoute = 'workitems';
        this.spacesString = 'spaces';
        if (this.auth && this.auth.getToken && this.auth.getToken() !== null) {
            this.headers = this.headers.set('Authorization', 'Bearer ' + this.auth.getToken());
        }
        this.setMetaInformation();
    }
    /**
     * @return {?}
     */
    AddWorkFlowService.prototype.setMetaInformation = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var api = this.apiUrl;
        if (this.context && this.context.current) {
            this.context.current.subscribe(function (currentContext) {
                if (currentContext.space) {
                    _this.spaceId = currentContext.space.id;
                    _this.stackWorkItemUrl = api + _this.spacesString + '/' + _this.spaceId + '/' + _this.workItemsRoute;
                    if (currentContext.space.relationships && currentContext.space.relationships.workitemtypes && currentContext.space.relationships.workitemtypes.links) {
                        _this.fetchBugId(currentContext.space.relationships.workitemtypes.links.related);
                    }
                }
            });
        }
    };
    /**
     * @param {?} url
     * @return {?}
     */
    AddWorkFlowService.prototype.fetchBugId = /**
     * @param {?} url
     * @return {?}
     */
    function (url) {
        var _this = this;
        /** @type {?} */
        var options = { headers: this.headers };
        this.http.get(url, options)
            .pipe(catchError(this.handleError))
            .subscribe(function (json) {
            try {
                if (json) {
                    _this.setBugId(json);
                }
            }
            catch (error) {
                console.log('Error converting response to JSON');
            }
        });
    };
    /**
     * @param {?} response
     * @return {?}
     */
    AddWorkFlowService.prototype.setBugId = /**
     * @param {?} response
     * @return {?}
     */
    function (response) {
        if (response && response.data) {
            /** @type {?} */
            var data = response.data;
            /** @type {?} */
            var dataItem = void 0;
            for (var i in data) {
                if (data.hasOwnProperty(i)) {
                    dataItem = data[i];
                    if (dataItem) {
                        if (dataItem.attributes) {
                            /** @type {?} */
                            var id = dataItem.id;
                            /** @type {?} */
                            var attributes = dataItem.attributes;
                            if (attributes && attributes['can-construct'] === true) {
                                if (!this.fallBackBugId) {
                                    this.fallBackBugId = id;
                                }
                            }
                            if (attributes && attributes.name === 'Bug') {
                                this.bugId = id;
                                break;
                            }
                        }
                    }
                }
            }
        }
    };
    /**
     * @param {?} workItemData
     * @return {?}
     */
    AddWorkFlowService.prototype.addWorkFlow = /**
     * @param {?} workItemData
     * @return {?}
     */
    function (workItemData) {
        workItemData.data.relationships.baseType.data.id = this.bugId || this.fallBackBugId;
        /** @type {?} */
        var options = { headers: this.headers };
        /** @type {?} */
        var body = JSON.stringify(workItemData);
        return this.http.post(this.stackWorkItemUrl, body, options)
            .pipe(map(this.extractData), catchError(this.handleError));
    };
    /**
     * @private
     * @param {?} body
     * @return {?}
     */
    AddWorkFlowService.prototype.extractData = /**
     * @private
     * @param {?} body
     * @return {?}
     */
    function (body) {
        return body || {};
    };
    /**
     * @private
     * @param {?} error
     * @return {?}
     */
    AddWorkFlowService.prototype.handleError = /**
     * @private
     * @param {?} error
     * @return {?}
     */
    function (error) {
        /** @type {?} */
        var errMsg;
        if (error.error instanceof ErrorEvent) {
            errMsg = error.error.message || error.error.toString();
        }
        else {
            /** @type {?} */
            var body = error.error || '';
            /** @type {?} */
            var err = body.error || JSON.stringify(body);
            errMsg = error.status + " - " + (error.statusText || '') + " " + err;
        }
        return throwError(errMsg);
    };
    AddWorkFlowService.decorators = [
        { type: Injectable }
    ];
    /** @nocollapse */
    AddWorkFlowService.ctorParameters = function () { return [
        { type: HttpClient },
        { type: String, decorators: [{ type: Inject, args: [WIT_API_URL,] }] },
        { type: AuthenticationService },
        { type: Contexts }
    ]; };
    return AddWorkFlowService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentInformationComponent = /** @class */ (function () {
    function ComponentInformationComponent(addWorkFlowService, context) {
        var _this = this;
        this.addWorkFlowService = addWorkFlowService;
        this.context = context;
        this.workItemResponse = [];
        if (this.context && this.context.current) {
            this.context.current.subscribe(function (val) {
                if (val && val.name) {
                    _this.spaceName = val.name.trim().replace(' ', '_');
                }
                _this.userName = val.user.attributes.username;
            });
        }
        this.messages = {
            createWorkItemEerror: 'There was a error while creating work item.',
            toastDisplay: {
                text1: 'Workitem with ID ',
                text2: ' has been added to the backlog.'
            },
            viewWorkItem: 'View Work Item'
        };
    }
    /**
     * @return {?}
     */
    ComponentInformationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.paint();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ComponentInformationComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['component'];
        if (summary) {
            this.component = (/** @type {?} */ (summary.currentValue));
        }
        if (changes['positions']) {
            this.positions = changes['positions']['currentValue'];
        }
        this.paint();
    };
    /**
     * @return {?}
     */
    ComponentInformationComponent.prototype.paint = /**
     * @return {?}
     */
    function () {
        if (this.component) {
            if (this.type === 'recommendation') {
                /** @type {?} */
                var c = ((/** @type {?} */ (this.component)));
                this.comp = c && c.componentInformation;
            }
            else {
                this.comp = (/** @type {?} */ (this.component));
            }
        }
    };
    /**
     * @param {?} event
     * @param {?} comp
     * @return {?}
     */
    ComponentInformationComponent.prototype.handleAction = /**
     * @param {?} event
     * @param {?} comp
     * @return {?}
     */
    function (event, comp) {
        event.preventDefault();
        /** @type {?} */
        var workItems = [];
        /** @type {?} */
        var message = '';
        /** @type {?} */
        var codebase = {
            'repository': '',
            'branch': '',
            'filename': this.component['manifestFilePath'],
            'linenumber': 1
        };
        /** @type {?} */
        var key = '';
        // TODO form data to be shared with recommender object
        /** @type {?} */
        var titleHdr = '';
        if (comp && comp.recommendation) {
            message = "Stack analysis has identified alternate component\n            for **" + comp.name + "**.\n            You have chosen to replace **" + comp.name + "** with **" + comp.recommendation.componentInformation.name + "**\n            and version: **" + comp.recommendation.componentInformation.currentVersion + "** in your application stack";
            titleHdr = "Alternate dependencies for " + comp.name;
            key = comp.recommendation.componentInformation.name;
        }
        else if (comp && !comp.hasSecurityIssue && !comp.recommendation) {
            message = "Stack analysis has identified some additional dependencies for your\n            application stack. You have chosen to add **" + comp.name + "**\n            with **" + comp.currentVersion + "** to your application stack";
            titleHdr = "Add " + comp.name + " to your application stack";
            key = comp.name;
        }
        else if (comp && comp.hasSecurityIssue) {
            message = "Stack analysis has identified some security issues for dependency **" + comp.name + "**\n            with **" + comp.currentVersion + "** in your application stack. CVE id for the highest security\n             issue is **" + comp.securityDetails.highestIssue.cve + "**";
            titleHdr = comp.name + " has some security issues";
            key = comp.name;
        }
        if (this.repoInfo && this.repoInfo.git) {
            codebase['repository'] = this.repoInfo.git.uri || '';
            codebase['branch'] = this.repoInfo.git.ref || 'master';
        }
        message += ' \n\n ';
        message += '\n\n **Repository:** ' + codebase['repository'];
        message += '\n\n **Branch:** ' + codebase['branch'];
        message += '\n\n **Filename:** ' + codebase['filename'];
        message += '\n\n **Line Number:**' + codebase['linenumber'];
        /** @type {?} */
        var item = {
            title: titleHdr,
            description: {
                content: message,
                markup: 'Markdown'
            },
            codebase: codebase,
            key: key
        };
        workItems.push(item);
        if (workItems.length > 0) {
            this.addWorkItems(workItems[0], comp);
        }
        else {
            console.log('Work items are empty and cannot be added');
        }
    };
    /*
     *  getWorkItemData - Takes nothing, returns Object
     *  It returns the predefined JSON structure to be sent as an input
     *  for work item creation request.
     */
    /*
         *  getWorkItemData - Takes nothing, returns Object
         *  It returns the predefined JSON structure to be sent as an input
         *  for work item creation request.
         */
    /**
     * @private
     * @return {?}
     */
    ComponentInformationComponent.prototype.getWorkItemData = /*
         *  getWorkItemData - Takes nothing, returns Object
         *  It returns the predefined JSON structure to be sent as an input
         *  for work item creation request.
         */
    /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var workItemData = {
            'data': {
                'attributes': {
                    'system.title': '',
                    'system.codebase': ''
                },
                'type': 'workitems',
                'relationships': {
                    'baseType': {
                        'data': {
                            'id': '',
                            'type': 'workitemtypes'
                        }
                    }
                }
            }
        };
        return workItemData;
    };
    /*
     *  addWorkItems - takes workitems array, return nothing
     *  A generic function that recieves workitems in a predefined format
     *  Creates work items based on the data
     *  Handles single as well as multiple work items
     */
    /*
         *  addWorkItems - takes workitems array, return nothing
         *  A generic function that recieves workitems in a predefined format
         *  Creates work items based on the data
         *  Handles single as well as multiple work items
         */
    /**
     * @private
     * @param {?} workItem
     * @param {?} comp
     * @return {?}
     */
    ComponentInformationComponent.prototype.addWorkItems = /*
         *  addWorkItems - takes workitems array, return nothing
         *  A generic function that recieves workitems in a predefined format
         *  Creates work items based on the data
         *  Handles single as well as multiple work items
         */
    /**
     * @private
     * @param {?} workItem
     * @param {?} comp
     * @return {?}
     */
    function (workItem, comp) {
        var _this = this;
        /** @type {?} */
        var newItem;
        newItem = this.getWorkItemData();
        // for (let i: number = 0; i < length; ++i) {
        // if (workItems[i]) {
        // workItem = workItems[i];
        // TODO: Handle the case of sending multiple work items concurrently
        // once the API Payload is properly set at the receiving end.
        if (newItem) {
            newItem.data.attributes['system.title'] = workItem['title'];
            newItem.data.attributes['system.description'] = workItem['description'];
            newItem.data.attributes['system.codebase'] = workItem['codebase'];
            newItem.data.attributes['system.description.markup'] = workItem['markup'];
            newItem.key = workItem['key'];
        }
        // }
        // }
        /** @type {?} */
        var workFlow = this.addWorkFlowService.addWorkFlow(newItem);
        workFlow.subscribe(function (data) {
            if (data) {
                /** @type {?} */
                var inputUrlArr = [];
                if (data.links && data.links.self && data.links.self.length &&
                    data.data.attributes) {
                    comp.workItem.isWorkItemCreated = true;
                    inputUrlArr = data.links.self.split('/api/');
                    /** @type {?} */
                    var hostString = inputUrlArr[0] ? inputUrlArr[0].replace('api.', '') : '';
                    /** @type {?} */
                    var baseUrl = hostString +
                        ("/" + _this.userName + "/" + _this.getSpaceName(_this.spaceName) + "/plan/detail/") +
                        data.data.attributes['system.number'];
                    comp.workItem.url = baseUrl;
                    _this.displayWorkItemResponse(baseUrl, data.data.attributes['system.number']);
                    newItem.url = baseUrl;
                    // TODO :: toggle Worke item link and toast notification
                    // this.toggleWorkItemButton(newItem);
                }
            }
        });
    };
    /**
     * @private
     * @param {?} spaceName
     * @return {?}
     */
    ComponentInformationComponent.prototype.getSpaceName = /**
     * @private
     * @param {?} spaceName
     * @return {?}
     */
    function (spaceName) {
        spaceName = spaceName.replace(/\s/g, '_');
        return spaceName;
    };
    /**
     * displayWorkItemResponse - takes a message string and returns nothing
     * Displays the response received from the creation of work items
     */
    /**
     * displayWorkItemResponse - takes a message string and returns nothing
     * Displays the response received from the creation of work items
     * @private
     * @param {?} url
     * @param {?} id
     * @return {?}
     */
    ComponentInformationComponent.prototype.displayWorkItemResponse = /**
     * displayWorkItemResponse - takes a message string and returns nothing
     * Displays the response received from the creation of work items
     * @private
     * @param {?} url
     * @param {?} id
     * @return {?}
     */
    function (url, id) {
        /** @type {?} */
        var notification = {
            iconClass: '',
            alertClass: '',
            text: null,
            link: null,
            linkText: this.messages.viewWorkItem
        };
        if (id) {
            notification.iconClass = 'pficon-ok';
            notification.alertClass = 'alert-success';
            notification.text = this.messages.toastDisplay.text1 +
                id + this.messages.toastDisplay.text2;
            notification.link = url;
        }
        else {
            notification.iconClass = 'pficon-error-circle-o';
            notification.alertClass = 'alert-danger';
            notification.text = this.messages.createWorkItemEerror;
        }
        this.workItemResponse.push(notification);
    };
    ComponentInformationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'component-information',
                    template: "<fab-toast-notification [notifications]=\"workItemResponse\"></fab-toast-notification>\n<div class=\"analytics-component-information\">\n    <div [ngClass]=\"{'card-pf card-pf-view card-pf-view-xs': true, 'active-card': comp?.isOpen}\">\n        <div class=\"card-pf-body clear-float header-group\">\n            <div class=\"main-content\">\n                <div [class]=\"position?.className\" *ngFor=\"let position of positions;\">\n                    <div [ngSwitch]=\"position?.identifier\">\n                        <!-- Security Card -->\n                        <div *ngSwitchCase=\"'serial'\">\n                            <!-- Serial Numbers -->\n                            <span [innerText]=\"serial + 1\"></span>\n                        </div>\n                        <div *ngSwitchCase=\"'component'\">\n                            <!-- Dependency Names -->\n                            <span [innerText]=\"comp?.name\"></span>\n                            <span class=\"recommendation-reason\" [tooltip]=\"component['reason']\" *ngIf=\"component['reason'] && type === 'recommendation' && comp?.name\">Why this dependency?</span>\n                            <!--\n                                <reco-name [name]=\"comp?.name\" [reason]=\"comp?.recommendation?.reason\" *ngIf=\"comp?.recommendation && (comp?.recommendation?.type === 'companion')\"></reco-name>\n                            -->\n                        </div>\n                        <div *ngSwitchCase=\"'cveCount'\">\n                            <!-- cveCount -->\n                            <span [innerText]=\"comp?.securityDetails && comp?.securityDetails.totalIssues || 0\"></span>\n                        </div>\n                        <div *ngSwitchCase=\"'highestCVSS'\">\n                            <!-- highestCVSS -->\n                            <span *ngIf=\"!comp?.hasSecurityIssue\" [innerText]=\"'NA'\"></span>\n                            <ana-progress-meter *ngIf=\"comp?.hasSecurityIssue\" [config]=\"comp?.securityDetails?.progressReport\"></ana-progress-meter>\n                        </div>\n                        <div *ngSwitchCase=\"'cveIdOfH'\">\n                            <!-- cveIdOfHeighest CVSS -->\n                            <span *ngIf=\"!comp?.hasSecurityIssue\" [innerText]=\"'NA'\"></span>\n                            <span *ngIf=\"comp?.hasSecurityIssue\" [innerText]=\"comp?.securityDetails && comp?.securityDetails?.highestIssue?.cve\"></span>\n                        </div>\n                        <div *ngSwitchCase=\"'action'\" class=\"action\">\n                            <!-- Action -->\n                            <span *ngIf=\"!comp?.workItem?.isWorkItemCreated && comp?.action\" (click)=\"handleAction($event, comp)\" [innerText]=\"comp?.action\" class=\"not-created\"></span>\n                            <span *ngIf=\"!comp?.workItem?.isWorkItemCreated && !comp?.action\" [innerText]=\"'-----'\"></span>\n                            <span *ngIf=\"comp?.workItem?.isWorkItemCreated\">\n                                Work item created\n                                <a class=\"created\" target=\"_blank\" href=\"{{comp?.workItem?.url}}\">View here</a>\n                            </span>\n                        </div>\n                        <!-- Security Card -->\n\n                        \n                        \n                        <!-- Insights Card -->\n                        <div *ngSwitchCase=\"'alternate'\">\n                            <!-- alternate -->\n                            <span [innerText]=\"comp?.recommendation?.componentInformation?.name || '------'\"></span>\n                            <span class=\"recommendation-reason\" [tooltip]=\"comp?.recommendation?.reason\" *ngIf=\"comp?.recommendation?.reason && comp?.recommendation?.componentInformation?.name\">Why this dependency?</span>\n                        </div>\n                        <div *ngSwitchCase=\"'feedback'\">\n                            <!-- feedback -->\n                            <component-feedback [feedback]=\"component?.recommendation?.feedback || component?.feedback\"></component-feedback>\n                        </div>\n                        <div *ngSwitchCase=\"'confidence'\">\n                            <!-- confidence -->\n                            <ana-progress-meter *ngIf=\"comp?.recommendation?.confidenceScore\" [config]=\"comp?.recommendation?.confidenceScore\"></ana-progress-meter>\n                            <ana-progress-meter *ngIf=\"component?.confidenceScore\" [config]=\"component?.confidenceScore\"></ana-progress-meter>\n                            <span *ngIf=\"!comp?.recommendation?.confidenceScore && !component?.confidenceScore\">-----</span>\n                        </div>\n                        <!-- Insights Card -->\n\n                        \n                        \n                        <!-- Licenses Card -->\n                        <div *ngSwitchCase=\"'licensesAffected'\">\n                            <!-- licensesAffected -->\n                        </div>\n                        <div *ngSwitchCase=\"'unknownLicenses'\">\n                            <!-- unknownLicenses -->\n                            <span *ngFor=\"let unknown of comp?.licenseInformation?.unknownLicenses; let i = index\">\n                                <span [innerText]=\"unknown\"></span>\n                                <span *ngIf=\"i < comp?.licenseInformation?.unknownLicenses?.length - 1\">,</span>\n                                <br *ngIf=\"i < comp?.licenseInformation?.unknownLicenses?.length - 1\">\n                            </span>\n                        </div>\n                        <!-- Licenses Card -->\n\n                        \n                        \n                        <!-- Dependency Details Card -->\n                        <div *ngSwitchCase=\"'componentCheck'\">\n                            <!-- componentCheck -->\n                            <span [ngClass]=\"{'indicator security': true, 'pficon-warning-triangle-o security-issue': component?.hasSecurityIssue, 'pficon-ok': !component?.hasSecurityIssue}\"></span>\n                            <span [ngClass]=\"{'indicator usage': true, 'pficon-warning-triangle-o usage-outlier': component?.isUsageOutlier, 'pficon-ok': !component?.isUsageOutlier}\"></span>\n                            <span [ngClass]=\"{'indicator license': true, 'pficon-warning-triangle-o license-issue': component?.hasLicenseIssue, 'pficon-ok': !component?.hasLicenseIssue}\"></span>\n                        </div>\n                        <div *ngSwitchCase=\"'helpUsKnownMore'\">\n                            <!-- Help us know more about dependencies - get tags -->\n                        </div>\n                        <div *ngSwitchCase=\"'collapse'\">\n                            <!-- Toggle -->\n                            <div class=\"toggler\">\n                                <i [ngClass]=\"{'fa': true, 'fa-angle-up': comp?.isOpen, 'fa-angle-down': !comp?.isOpen}\" aria-hidden=\"true\"></i>\n                            </div>\n                        </div>\n                        <!-- Dependency Details Card -->\n                    </div>\n                </div>\n            </div>\n            \n            <div *ngIf=\"comp?.isOpen\" class=\"accordion-body\">\n                <div [ngClass]=\"{'col-xs-12': true, 'col-md-6 common-section': comp?.recommendation, 'col-md-12': !comp?.recommendation}\" *ngIf=\"comp\">\n                    <component-snippet [view]=\"!comp?.recommendation ? 'normal' : 'split'\" [component]=\"comp\"></component-snippet>\n                </div>\n                <div class=\"col-xs-12 col-md-6 recommendation-section common-section\" *ngIf=\"comp?.recommendation?.componentInformation\">\n                    <component-snippet [view]=\"'split'\" [component]=\"comp?.recommendation?.componentInformation\"></component-snippet>\n                </div>\n            </div>\n        </div>\n    </div>\n</div>\n",
                    styles: [".analytics-component-information .recommendation-reason{font-size:10px;color:#999;cursor:pointer}.analytics-component-information .recommendation-reason:before{content:'';clear:both;display:block;float:none}.analytics-component-information .active-card{border:1px solid #39a5dc}.analytics-component-information .card-pf{min-height:75px;margin:10px 0}.analytics-component-information .toggler{cursor:pointer;padding:2px 20px;font-size:25px;text-align:center;border-left:1px solid #ccc;line-height:25px}.analytics-component-information .float-left{float:left}.analytics-component-information .float-right{float:right}.analytics-component-information .extra-small{width:20px}.analytics-component-information .extra-medium{width:15%}.analytics-component-information .small{width:8%}.analytics-component-information .medium{width:25%}.analytics-component-information .large{width:30%}.analytics-component-information .text-center{text-align:center}.analytics-component-information .indicator{width:15px;height:15px;display:inline-block;margin:0 25px 0 0;position:relative}.analytics-component-information .indicator .pseudo-text-class{color:#7e7e7e;display:block;position:absolute;text-align:center;bottom:-15px;left:-7px;font-size:10px}.analytics-component-information .indicator .warning{color:#ec7a08}.analytics-component-information .indicator.security:after{content:'Security';color:#7e7e7e;display:block;position:absolute;text-align:center;bottom:-15px;font-size:10px;left:-11px}.analytics-component-information .indicator.usage:after{content:'Usage';color:#7e7e7e;display:block;position:absolute;text-align:center;bottom:-15px;font-size:10px;left:-6px}.analytics-component-information .indicator.license:after{content:'License';color:#7e7e7e;display:block;position:absolute;text-align:center;bottom:-15px;font-size:10px;left:-9px}.analytics-component-information .indicator.license-issue:before,.analytics-component-information .indicator.security-issue:before,.analytics-component-information .indicator.usage-outlier:before{color:#ec7a08}.analytics-component-information .common-section{padding-left:5%;margin-top:15px}.analytics-component-information .recommendation-section{border-left:1px solid #ccc}.analytics-component-information .clear-float:after{content:'';float:none;clear:both;display:block}.analytics-component-information .action .created,.analytics-component-information .action .not-created{cursor:pointer;color:#2a9fd8}"]
                }] }
    ];
    /** @nocollapse */
    ComponentInformationComponent.ctorParameters = function () { return [
        { type: AddWorkFlowService },
        { type: Contexts }
    ]; };
    ComponentInformationComponent.propDecorators = {
        component: [{ type: Input }],
        positions: [{ type: Input }],
        genericInformation: [{ type: Input }],
        serial: [{ type: Input }],
        type: [{ type: Input }],
        repoInfo: [{ type: Input }]
    };
    return ComponentInformationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ComponentDetailsComponent = /** @class */ (function () {
    function ComponentDetailsComponent() {
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ComponentDetailsComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['compDetails'];
        if (summary) {
            this.compDetails = (/** @type {?} */ (summary.currentValue));
        }
        if (changes['positions']) {
            this.positions = changes['positions']['currentValue'];
        }
    };
    ComponentDetailsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'component-details',
                    template: "<div class=\"analytics-component-details\">\n    <div *ngIf=\"type === 'component'\" class=\"component-information-container\">\n        <component-information [genericInformation]=\"genericInformation\" [type]=\"type\" [serial]=\"serial\" [positions]=\"positions\" [component]=\"compDetails?.componentInformation\" [repoInfo]=\"repoInfo\"></component-information>\n    </div>\n    <div *ngIf=\"type === 'recommendation'\" class=\"component-information-container\">\n        <component-information [genericInformation]=\"genericInformation\" [type]=\"type\" [serial]=\"serial\" [positions]=\"positions\" [component]=\"compDetails?.recommendationInformation\" [repoInfo]=\"repoInfo\"></component-information>\n    </div>\n</div>\n",
                    styles: [""]
                }] }
    ];
    ComponentDetailsComponent.propDecorators = {
        compDetails: [{ type: Input }],
        positions: [{ type: Input }],
        type: [{ type: Input }],
        serial: [{ type: Input }],
        genericInformation: [{ type: Input }],
        repoInfo: [{ type: Input }]
    };
    return ComponentDetailsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ReportInformationComponent = /** @class */ (function () {
    function ReportInformationComponent() {
        this.componentDetails = null;
    }
    /**
     * @return {?}
     */
    ReportInformationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    ReportInformationComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['report'];
        if (summary) {
            this.report = (/** @type {?} */ (summary.currentValue));
            this.paint();
        }
    };
    /**
     * @param {?} event
     * @param {?} componentDetail
     * @return {?}
     */
    ReportInformationComponent.prototype.handleAccordion = /**
     * @param {?} event
     * @param {?} componentDetail
     * @return {?}
     */
    function (event, componentDetail) {
        /** @type {?} */
        var elem = ((/** @type {?} */ (event.target)));
        if (this.checkIfClickable(elem)) {
            this.closeAllButThis(componentDetail);
            if ((componentDetail.componentInformation && !componentDetail.componentInformation.needsExpansion) ||
                (componentDetail.recommendationInformation && componentDetail.recommendationInformation.componentInformation &&
                    !componentDetail.recommendationInformation.componentInformation.needsExpansion)) {
                return;
            }
            if (componentDetail.componentInformation) {
                componentDetail.componentInformation.isOpen = !componentDetail.componentInformation.isOpen;
            }
            if (componentDetail.recommendationInformation) {
                if (componentDetail.recommendationInformation.componentInformation) {
                    componentDetail.recommendationInformation.componentInformation.isOpen = !componentDetail.recommendationInformation.componentInformation.isOpen;
                }
            }
        }
    };
    /**
     * @private
     * @param {?} elem
     * @return {?}
     */
    ReportInformationComponent.prototype.checkIfClickable = /**
     * @private
     * @param {?} elem
     * @return {?}
     */
    function (elem) {
        if (elem && elem.classList && elem.classList.contains('toggler')) {
            return true;
        }
        elem = (/** @type {?} */ (elem.parentNode));
        return (elem && elem.classList && elem.classList.contains('toggler'));
    };
    /**
     * @private
     * @return {?}
     */
    ReportInformationComponent.prototype.paint = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.report) {
            if (this.report.componentDetails && this.report.componentDetails.length > 0) {
                this.componentDetails = this.report.componentDetails;
            }
        }
    };
    /**
     * @private
     * @param {?} componentDetail
     * @return {?}
     */
    ReportInformationComponent.prototype.closeAllButThis = /**
     * @private
     * @param {?} componentDetail
     * @return {?}
     */
    function (componentDetail) {
        if (this.componentDetails) {
            this.componentDetails.forEach(function (cdetail) {
                if (cdetail !== componentDetail) {
                    if (cdetail.componentInformation) {
                        cdetail.componentInformation.isOpen = false;
                    }
                    if (cdetail.recommendationInformation) {
                        if (cdetail.recommendationInformation.componentInformation) {
                            cdetail.recommendationInformation.componentInformation.isOpen = false;
                        }
                    }
                }
            });
        }
    };
    ReportInformationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'report-information',
                    template: "<div class=\"analytics-report-information\">\n    <div *ngIf=\"report?.componentDetails && report?.componentDetails.length > 0\" class=\"component-detail-headers\">\n        <div [class]=\"header.className\" *ngFor=\"let header of report?.headers\" [innerText]=\"header.text\"></div>\n    </div>\n    <component-details [genericInformation]=\"genericInformation\" (click)=\"handleAccordion($event, cdetail)\" [serial]=\"i\" [type]=\"report?.type\" [positions]=\"report?.headers\" [compDetails]=\"cdetail\" [repoInfo]=\"repoInfo\" *ngFor=\"let cdetail of report?.componentDetails; let i = index;\"></component-details>\n    <no-data *ngIf=\"!report?.componentDetails || report?.componentDetails.length === 0\" [identifier]=\"report?.identifier\"></no-data>\n</div>\n",
                    styles: [".analytics-report-information .component-detail-headers{padding:10px 20px 0;font-weight:700;font-size:13px}.analytics-report-information .component-detail-headers .float-left{float:left}.analytics-report-information .component-detail-headers .extra-small{width:20px}.analytics-report-information .component-detail-headers .small{width:8%}.analytics-report-information .component-detail-headers .medium{width:25%}.analytics-report-information .component-detail-headers .extra-medium{width:15%}.analytics-report-information .component-detail-headers .large{width:30%}.analytics-report-information .component-detail-headers .text-center{text-align:center}.analytics-report-information .component-detail-headers .float-right{float:right}.analytics-report-information .component-detail-headers:after{content:'';float:none;clear:both;display:block}.no-data{width:60%;margin:0 auto;text-align:center}"]
                }] }
    ];
    ReportInformationComponent.propDecorators = {
        report: [{ type: Input }],
        genericInformation: [{ type: Input }],
        repoInfo: [{ type: Input }]
    };
    return ReportInformationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * Vendor imports Go HERE
 */
var NoDataComponent = /** @class */ (function () {
    function NoDataComponent() {
        this.title = '';
        this.description = '';
        this.TITLE_AND_DESCRIPTION = {
            'security': {
                title: 'No security issues',
                description: 'Openshift.io Analytics has not identified any security issues affecting the dependencies of this stack.'
            },
            'ins-usage': {
                title: 'No usage outliers',
                description: 'Openshift.io Analytics has not identified any usage outliers and has no suggestions for alternate dependencies for this stack.'
            },
            'lic-conflicts': {
                title: 'No license conflicts',
                description: 'Openshift.io Analytics could not find any conflicting licences in this stack.'
            },
            'comp-analyzed': {
                title: 'No analyzed dependencies',
                description: 'Openshift.io Analytics was unable to analyze any dependencies for this stack.'
            },
            'ins-companion': {
                title: 'No companion dependencies',
                description: 'Openshift.io Analytics has no suggestions for companion dependencies for this stack.'
            },
            'lic-unknown': {
                title: 'No unknown licenses',
                description: 'Openshift.io Analytics could not find any unknown licences in this stack.'
            },
            'comp-unknown': {
                title: 'No unknown dependencies',
                description: 'Openshift.io Analytics has analyzed all the dependencies in this stack.'
            },
        };
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    NoDataComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['identifier'];
        if (summary && summary['currentValue']) {
            this.identifier = (/** @type {?} */ (summary['currentValue']));
            this.paint();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NoDataComponent.prototype.paint = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.identifier) {
            /** @type {?} */
            var configObject = this.TITLE_AND_DESCRIPTION[this.identifier];
            if (configObject) {
                this.title = configObject.title;
                this.description = configObject.description;
            }
        }
    };
    NoDataComponent.decorators = [
        { type: Component, args: [{
                    selector: 'no-data',
                    template: "<div class=\"not-found\">\n    <div class=\"no-data\">\n        <h3 [innerHTML]=\"title\"></h3>\n        <p [innerHTML]=\"description\"></p>\n    </div>\n</div>\n",
                    styles: [".no-data{width:60%}"]
                }] }
    ];
    NoDataComponent.propDecorators = {
        identifier: [{ type: Input }]
    };
    return NoDataComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var components = [
    ComponentSnippetComponent,
    ComponentInformationComponent,
    ComponentDetailsComponent,
    ReportInformationComponent,
    NoDataComponent
];
/** @type {?} */
var imports$2 = [
    TooltipModule.forRoot(),
    ProgressMeterModule,
    ComponentFeedbackModule,
    ToastNotificationModule
];
var ReportInformationModule = /** @class */ (function () {
    function ReportInformationModule() {
    }
    ReportInformationModule.decorators = [
        { type: NgModule, args: [{
                    imports: __spread([
                        CommonModule
                    ], imports$2),
                    declarations: __spread(components),
                    providers: [AddWorkFlowService],
                    exports: __spread(components)
                },] }
    ];
    return ReportInformationModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CardDetailsComponent = /** @class */ (function () {
    function CardDetailsComponent() {
        var _a;
        this.details = null;
        this.tabs = [];
        this.USER_ACTION = {
            'security': 'Log a bug',
            'recommendation': 'Create work item'
        };
        this.cardTypes = {
            SECURITY: 'security',
            INSIGHTS: 'insights',
            LICENSES: 'licenses',
            COMP_DETAILS: 'compDetails'
        };
        this.titleAndDescription = (_a = {},
            _a[this.cardTypes.SECURITY] = {
                title: 'Dependencies with security issues in your stack',
                description: 'A list of the dependencies affected with common vulnerabilities and exposures (CVE), dependency with the highest common vulnerability score (CVSS), and its CVE ID. You can take corrective actions by reporting the issues.'
            },
            _a[this.cardTypes.INSIGHTS] = {
                title: 'Insights on alternate or additional dependencies that can augment your stack',
                description: 'A list of dependencies that are not commonly used in similar stacks, suggestions for alternate dependencies to replace them, and suggestions for additional dependencies to complement your stack. Take corrective action by creating a work item in planner or leave us feedback.'
            },
            _a[this.cardTypes.LICENSES] = {
                title: 'License details of dependencies in your stack',
                description: 'A list of stack and dependency level license conflicts, licenses unknown to Openshift.io and suggestions for alternate dependencies to resolve these issues. Create a work item in planner to replace these dependencies.'
            },
            _a[this.cardTypes.COMP_DETAILS] = {
                title: 'Dependency details of your manifest file',
                description: 'A list of all the analyzed dependencies that flags security, usage, and license issues in your stack and suggests alternate dependencies to replace dependencies with these issues. Take corrective action by creating a work item in planner. It also lists dependencies unknown to Openshift.io.'
            },
            _a);
    }
    /**
     * @return {?}
     */
    CardDetailsComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.paint();
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    CardDetailsComponent.prototype.ngOnChanges = /**
     * @param {?} changes
     * @return {?}
     */
    function (changes) {
        /** @type {?} */
        var summary = changes['cardDetails'];
        if (summary) {
            this.cardDetails = (/** @type {?} */ (summary.currentValue));
            if (this.cardDetails && this.cardDetails.report) {
                this.report = this.cardDetails.report;
            }
            else {
                this.report = null;
            }
            this.whatCard = this.cardDetails && this.cardDetails.cardType || null;
            this.paint();
        }
    };
    /**
     * @private
     * @param {?} cardType
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.canInclude = /**
     * @private
     * @param {?} cardType
     * @param {?} component
     * @return {?}
     */
    function (cardType, component) {
        /** @type {?} */
        var processFlag = true;
        if (component) {
            switch (cardType) {
                case 'security':
                    processFlag = component.securityDetails && component.securityDetails.totalIssues > 0;
                    break;
                case 'insights':
                    processFlag = component.isUsageOutlier;
                    break;
                case 'licenses':
                    processFlag = component.hasLicenseIssue;
                    break;
                case 'compDetails':
                    processFlag = true;
                    break;
                default:
                    break;
            }
            return processFlag;
        }
        return false;
    };
    /**
     * @private
     * @param {?} type
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getMComponentFeedback = /**
     * @private
     * @param {?} type
     * @param {?} component
     * @return {?}
     */
    function (type, component) {
        /** @type {?} */
        var feedback = null;
        if (this.genericInformation && this.genericInformation.stackId && component) {
            feedback = new MComponentFeedback(new MFeedbackTemplate(this.genericInformation.stackId, type, component.name, null, component.ecosystem), this.genericInformation.baseUrl);
        }
        return feedback;
    };
    /**
     * @private
     * @return {?}
     */
    CardDetailsComponent.prototype.getCompanionComponents = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var companions = [];
        if (this.report) {
            if (this.report.recommendation
                && this.report.recommendation.companion
                && this.report.recommendation.companion.length > 0) {
                /** @type {?} */
                var comps = this.report.recommendation.companion;
                comps.forEach(function (companion) {
                    /** @type {?} */
                    var security = _this.getComponentSecurity(companion);
                    /** @type {?} */
                    var progress = null;
                    if (companion && companion.confidence_reason) {
                        progress = new MProgressMeter(Math.round(companion.confidence_reason) + '%', Math.round(companion.confidence_reason), Math.round(companion.confidence_reason) > 50 ? '#6ec664' : 'ORANGE', '', Math.round(companion.confidence_reason));
                    }
                    companions.push(new MRecommendationInformation('companion', companion.reason, _this.getMComponentFeedback('companion', companion), progress, new MComponentInformation(companion.name, '-----', companion.latest_version, security, security !== null, false, false, companion.licenses, new MCrowdSourcing(companion.topic_list), _this.getMGithub(companion), new MOsio(companion.osio_user_count), 'Create work item', true, null, false, null, companion.ecosystem), _this.report.manifest_file_path));
                });
            }
        }
        return companions;
    };
    /**
     * @private
     * @return {?}
     */
    CardDetailsComponent.prototype.getCompanionComponentDetails = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var comps = this.getCompanionComponents();
        /** @type {?} */
        var compDetails = [];
        if (comps && comps.length > 0) {
            comps.forEach(function (comp) {
                compDetails.push(new MComponentDetails(null, comp));
            });
        }
        return compDetails;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.decideAction = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        /** @type {?} */
        var action = null;
        if (component) {
            if (component.recommendation) {
                if (component.recommendation.componentInformation) {
                    action = component.recommendation.componentInformation.action;
                }
            }
            else {
                if (component.securityDetails && component.securityDetails.totalIssues > 0) {
                    action = this.USER_ACTION.security;
                }
            }
        }
        return action;
    };
    /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    CardDetailsComponent.prototype.getUIReportInformations = /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    function (cardType) {
        var _this = this;
        /** @type {?} */
        var reportInformations = [];
        /** @type {?} */
        var componentDetails = [];
        /** @type {?} */
        var componentInformation = null;
        /** @type {?} */
        var recommendationInformation = null;
        /** @type {?} */
        var headers = this.fillColumnHeaders(cardType);
        /** @type {?} */
        var components = null;
        if (this.report.user_stack_info
            && this.report.user_stack_info.analyzed_dependencies
            && this.report.user_stack_info.analyzed_dependencies.length > 0) {
            components = this.report.user_stack_info.analyzed_dependencies;
        }
        if (components) {
            components.forEach(function (component) {
                componentInformation = _this.getComponentInformation(component);
                if (_this.canInclude(cardType, componentInformation)) {
                    componentInformation.action = _this.decideAction(componentInformation);
                    componentDetails.push(new MComponentDetails(componentInformation, recommendationInformation));
                }
            });
        }
        /** @type {?} */
        var genericReport = new MReportInformation(null, null, 'component', this.fillColumnHeaders(cardType, 1), componentDetails);
        /** @type {?} */
        var compDetails = [];
        switch (cardType) {
            case 'security':
                genericReport.identifier = 'security';
                genericReport.name = 'securityTab';
                reportInformations.push(genericReport);
                break;
            case 'insights':
                genericReport.identifier = 'ins-usage';
                genericReport.name = 'Usage Outlier Details';
                reportInformations.push(genericReport);
                compDetails = this.getCompanionComponentDetails();
                reportInformations.push(new MReportInformation('ins-companion', 'Companion Dependency Details', 'recommendation', this.fillColumnHeaders(cardType, 2), compDetails));
                break;
            case 'licenses':
                genericReport.identifier = 'lic-conflicts';
                genericReport.name = 'Conflicting License(s) Details';
                reportInformations.push(genericReport);
                compDetails = this.getUnknownLicenseComponentDetails();
                reportInformations.push(new MReportInformation('lic-unknown', 'Unknown License(s) Details', 'component', this.fillColumnHeaders(cardType, 2), compDetails));
                break;
            case 'compDetails':
                genericReport.identifier = 'comp-analyzed';
                genericReport.name = 'Analyzed Dependency Details';
                reportInformations.push(genericReport);
                compDetails = this.getUnknownComponentDetails(cardType);
                reportInformations.push(new MReportInformation('comp-unknown', 'Unknown Dependency Details', 'component', this.fillColumnHeaders(cardType, 2), compDetails));
                break;
            default:
                break;
        }
        return reportInformations;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.hasUnknownLicense = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        if (component) {
            /** @type {?} */
            var licenseAnalysis = this.getLicensesAnalysis();
            if (licenseAnalysis &&
                licenseAnalysis.unknown_licenses &&
                licenseAnalysis.unknown_licenses.really_unknown &&
                licenseAnalysis.unknown_licenses.really_unknown.length > 0) {
                /** @type {?} */
                var reallyUnknown = licenseAnalysis.unknown_licenses.really_unknown;
                /** @type {?} */
                var len = reallyUnknown.length;
                for (var i = 0; i < len; ++i) {
                    if (reallyUnknown[i].package === component.name) {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    /**
     * @private
     * @return {?}
     */
    CardDetailsComponent.prototype.getUnknownLicenseComponentDetails = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var unknownLicenseComps = null;
        /** @type {?} */
        var components = null;
        if (this.report.user_stack_info
            && this.report.user_stack_info.analyzed_dependencies
            && this.report.user_stack_info.analyzed_dependencies.length > 0) {
            components = this.report.user_stack_info.analyzed_dependencies;
        }
        if (components) {
            unknownLicenseComps = [];
            components.forEach(function (component) {
                if (_this.hasUnknownLicense(component)) {
                    unknownLicenseComps.push(new MComponentDetails(_this.getComponentInformation(component), null));
                }
            });
        }
        return unknownLicenseComps;
    };
    /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    CardDetailsComponent.prototype.getUnknownComponentDetails = /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    function (cardType) {
        /** @type {?} */
        var unknowns = [];
        /** @type {?} */
        var unknownComponents = (this.report && this.report.user_stack_info && this.report.user_stack_info.unknown_dependencies) || [];
        unknownComponents.forEach(function (unknown) {
            unknowns.push(new MComponentDetails(new MComponentInformation(unknown.name, unknown.version, '', null, null, null, null, null, null, null, null, null, false, null, false, null, null, null, null), null));
        });
        return unknowns;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getMGithub = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        /** @type {?} */
        var github = null;
        if (component && component.github) {
            /** @type {?} */
            var g = component.github;
            github = new MGithub(g.contributors, g.forks_count, g.dependent_repos, g.stargazers_count, g.used_by && g.used_by.length || -1, g.used_by);
        }
        return github;
    };
    /**
     * @private
     * @return {?}
     */
    CardDetailsComponent.prototype.getLicensesAnalysis = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.report) {
            if (this.report.user_stack_info
                && this.report.user_stack_info.license_analysis
                && this.report.user_stack_info.license_analysis) {
                return this.report.user_stack_info.license_analysis;
            }
        }
        return null;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.hasLicenseIssue = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        if (component) {
            /** @type {?} */
            var analysis = this.getLicensesAnalysis();
            if (analysis) {
                return (analysis.conflict_packages
                    && analysis.conflict_packages.length > 0)
                    || (analysis.unknown_licenses && analysis.unknown_licenses.component_conflict &&
                        analysis.unknown_licenses.component_conflict.length > 0);
            }
        }
        return false;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getComponentInformation = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        if (component) {
            /** @type {?} */
            var currentVersion = component.version;
            /** @type {?} */
            var latestVersion = component.latest_version;
            /** @type {?} */
            var github = component.github;
            /** @type {?} */
            var hasLicenseIssue = this.hasLicenseIssue(component);
            /** @type {?} */
            var isUsageOutlier = false;
            /** @type {?} */
            var securityDetails = this.getComponentSecurity(component);
            /** @type {?} */
            var recommendation = this.report.recommendation;
            /** @type {?} */
            var recommendationInformation = null;
            /** @type {?} */
            var usageOutliers = null;
            if (recommendation) {
                usageOutliers = recommendation.usage_outliers;
                if (usageOutliers) {
                    /** @type {?} */
                    var outlierLen = usageOutliers.length;
                    for (var i = 0; i < outlierLen; ++i) {
                        if (component.name === usageOutliers[i].package_name) {
                            isUsageOutlier = true;
                            break;
                        }
                    }
                }
                if (recommendation.alternate && recommendation.alternate.length > 0) {
                    /** @type {?} */
                    var alternates = recommendation.alternate;
                    /** @type {?} */
                    var alternatesLen = alternates.length;
                    for (var i = 0; i < alternatesLen; ++i) {
                        if (alternates[i].replaces && alternates[i].replaces[0] && alternates[i].replaces[0].name) {
                            /** @type {?} */
                            var alternate = alternates[i];
                            if (component.name === alternate.replaces[0].name) {
                                /** @type {?} */
                                var alterSecurity = this.getComponentSecurity(alternate);
                                /** @type {?} */
                                var progress = null;
                                if (alternate && alternate.confidence_reason) {
                                    progress = new MProgressMeter(Math.round(alternate.confidence_reason) + '%', Math.round(alternate.confidence_reason), Math.round(alternate.confidence_reason) > 50 ? '#6ec664' : 'ORANGE', '', Math.round(alternate.confidence_reason));
                                }
                                recommendationInformation = new MRecommendationInformation('alternate', alternate.reason, this.getMComponentFeedback('alternate', alternate), progress, new MComponentInformation(alternate.name, alternate.version, alternate.latest_version, alterSecurity, alterSecurity !== null, false, false, alternate.licenses, new MCrowdSourcing(alternate.topic_list), this.getMGithub(alternate), new MOsio(alternate.osio_user_count), 'Create work item', false, null, false, null, alternate.ecosystem));
                                break;
                            }
                        }
                    }
                }
            }
            return new MComponentInformation(component.name, currentVersion, latestVersion, securityDetails, securityDetails !== null, isUsageOutlier, hasLicenseIssue, component.licenses, new MCrowdSourcing(component.topic_list), this.getMGithub(component), new MOsio(component.osio_user_count), null, true, recommendationInformation, false, new MLicenseInformation(component.licenses, this.getUnknownLicenses(component), hasLicenseIssue, this.getMLicenseAffected(component)), component.ecosystem, this.report.manifest_file_path);
        }
        return null;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getUnknownLicenses = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        /** @type {?} */
        var unknownLicenses = [];
        if (component) {
            if (this.report) {
                /** @type {?} */
                var analysis = this.getLicensesAnalysis();
                if (analysis && analysis.unknown_licenses
                    && analysis.unknown_licenses.really_unknown
                    && analysis.unknown_licenses.really_unknown.length > 0) {
                    /** @type {?} */
                    var reallyUnknown = analysis.unknown_licenses.really_unknown;
                    reallyUnknown.forEach(function (unknown) {
                        if (unknown.package === component.name) {
                            unknownLicenses.push(unknown.license);
                        }
                    });
                }
            }
        }
        return unknownLicenses;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getMLicenseAffected = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        /** @type {?} */
        var licensesAffected = null;
        /** @type {?} */
        var analysis = this.getLicensesAnalysis();
        if (analysis) {
            licensesAffected = [];
            /** @type {?} */
            var licenseAnalysis = analysis;
            if (licenseAnalysis.status) {
                switch (licenseAnalysis.status.toLowerCase()) {
                    case 'componentconflict':
                        if (licenseAnalysis.unknown_licenses
                            && licenseAnalysis.unknown_licenses.component_conflict
                            && licenseAnalysis.unknown_licenses.component_conflict.length > 0) {
                            /** @type {?} */
                            var compConflicts = licenseAnalysis.unknown_licenses.component_conflict;
                            /** @type {?} */
                            var len = compConflicts.length;
                            var _loop_1 = function (i) {
                                if (compConflicts[i] && compConflicts[i].package === component.name) {
                                    /** @type {?} */
                                    var affectedLicenses_1 = [];
                                    if (compConflicts[i].conflict_licenses && compConflicts[i].conflict_licenses.length > 0) {
                                        compConflicts[i].conflict_licenses.forEach(function (license) {
                                            affectedLicenses_1.push(new MConflictsWithInLicenses(license.license1, license.license2));
                                        });
                                    }
                                    licensesAffected.push(new MLicensesAffected(affectedLicenses_1, 'componentconflict', null));
                                }
                            };
                            for (var i = 0; i < len; ++i) {
                                _loop_1(i);
                            }
                        }
                        break;
                    case 'stacklicenseconflict':
                        if (licenseAnalysis.conflict_packages
                            && licenseAnalysis.conflict_packages.length > 0) {
                            /** @type {?} */
                            var stackConflicts = licenseAnalysis.conflict_packages;
                            /** @type {?} */
                            var len = stackConflicts.length;
                            /** @type {?} */
                            var affectedComponents = [];
                            for (var i = 0; i < len; ++i) {
                                if (stackConflicts[i] && stackConflicts[i].package1 === component.name) {
                                    affectedComponents.push(new MStackLicenseConflictDetails(stackConflicts[i].license2, stackConflicts[i].package2, stackConflicts[i].license1));
                                }
                            }
                            licensesAffected.push(new MLicensesAffected(null, 'stackconflict', affectedComponents));
                        }
                        break;
                    case 'successful':
                        break;
                    case 'unknown':
                        break;
                    case 'failure':
                        break;
                    default:
                }
            }
        }
        return licensesAffected;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getComponentSecurityInformation = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        if (component) {
            /** @type {?} */
            var securityDetails = null;
            /** @type {?} */
            var securityIssues = 0;
            /** @type {?} */
            var maxIssue = null;
            /** @type {?} */
            var temp = null;
            if (component.security && component.security.length > 0) {
                securityDetails = new MSecurityDetails();
                /** @type {?} */
                var currSecurity = component.security;
                temp = currSecurity.reduce(function (a, b) {
                    return parseFloat(a.CVSS) < parseFloat(b.CVSS) ? b : a;
                });
                if (temp) {
                    if (maxIssue === null || maxIssue.CVSS < temp.CVSS) {
                        maxIssue = temp;
                    }
                }
                securityIssues += currSecurity.length;
                securityDetails.totalIssues = securityIssues;
            }
            if (maxIssue) {
                securityDetails.highestIssue = new MSecurityIssue(maxIssue.CVSS, maxIssue.CVE);
                securityDetails.progressReport = new MProgressMeter(Number(maxIssue.CVSS) + '/10', Number(maxIssue.CVSS), Number(maxIssue.CVSS) >= 7 ? '#d1011c' : 'ORANGE', '', Number(maxIssue.CVSS) * 10);
            }
            return securityDetails;
        }
        return null;
    };
    /**
     * @private
     * @param {?} component
     * @return {?}
     */
    CardDetailsComponent.prototype.getComponentSecurity = /**
     * @private
     * @param {?} component
     * @return {?}
     */
    function (component) {
        return this.getComponentSecurityInformation(component);
    };
    /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    CardDetailsComponent.prototype.getTitleAndDescription = /**
     * @private
     * @param {?} cardType
     * @return {?}
     */
    function (cardType) {
        var _a = this.titleAndDescription[cardType], title = _a.title, description = _a.description;
        return {
            title: title,
            description: description
        };
    };
    /**
     * @private
     * @param {?} cardType
     * @param {?=} tabNo
     * @return {?}
     */
    CardDetailsComponent.prototype.fillColumnHeaders = /**
     * @private
     * @param {?} cardType
     * @param {?=} tabNo
     * @return {?}
     */
    function (cardType, tabNo) {
        if (tabNo === void 0) { tabNo = null; }
        /** @type {?} */
        var headers = [];
        headers.push(new MComponentHeaderColumn('serial', '#', 'float-left extra-small'));
        switch (cardType) {
            case 'security':
                headers.push(new MComponentHeaderColumn('component', 'Dependencies', 'float-left medium'));
                headers.push(new MComponentHeaderColumn('cveCount', 'No. of CVE(s)', 'float-left small'));
                headers.push(new MComponentHeaderColumn('highestCVSS', 'Highest CVSS Score', 'float-left medium'));
                headers.push(new MComponentHeaderColumn('cveIdOfH', 'CVE ID of highest CVSS score', 'float-left medium'));
                headers.push(new MComponentHeaderColumn('action', 'Action', 'float-left small'));
                break;
            case 'insights':
                headers.push(new MComponentHeaderColumn('component', 'Dependencies', 'float-left medium'));
                if (tabNo === 1) {
                    headers.push(new MComponentHeaderColumn('alternate', 'Alternate Dependencies', 'float-left medium'));
                }
                headers.push(new MComponentHeaderColumn('confidence', 'Confidence Score', 'float-left extra-medium'));
                headers.push(new MComponentHeaderColumn('feedback', 'Feedback', 'float-left small'));
                headers.push(new MComponentHeaderColumn('action', 'Action', 'float-left small'));
                break;
            case 'licenses':
                headers.push(new MComponentHeaderColumn('component', 'Dependencies', 'float-left medium'));
                if (tabNo === 1) {
                    headers.push(new MComponentHeaderColumn('licensesAffected', 'Licenses Affected', 'float-left medium'));
                }
                else if (tabNo === 2) {
                    headers.push(new MComponentHeaderColumn('unknownLicenses', 'Unknown License', 'float-left medium'));
                }
                headers.push(new MComponentHeaderColumn('alternate', 'Alternate Dependencies', 'float-left medium'));
                headers.push(new MComponentHeaderColumn('action', 'Action', 'float-left small'));
                break;
            case 'compDetails':
                headers.push(new MComponentHeaderColumn('component', 'Dependencies', 'float-left medium'));
                if (tabNo === 1) {
                    headers.push(new MComponentHeaderColumn('componentCheck', 'Dependency Check', 'float-left medium'));
                    headers.push(new MComponentHeaderColumn('alternate', 'Alternate Dependencies', 'float-left medium'));
                    headers.push(new MComponentHeaderColumn('action', 'Action', 'float-left small'));
                }
                break;
            default:
                break;
        }
        headers.push(new MComponentHeaderColumn('collapse', '', 'float-right'));
        if (cardType === 'compDetails' && tabNo === 2) {
            headers.pop();
        }
        return headers;
    };
    /**
     * @private
     * @return {?}
     */
    CardDetailsComponent.prototype.paint = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.tabs = [];
        if (this.report && this.whatCard) {
            /** @type {?} */
            var reports = this.getUIReportInformations(this.whatCard);
            this.details = new MCardDetails();
            var _a = this.getTitleAndDescription(this.whatCard), title = _a.title, description = _a.description;
            this.details.reportInformations = reports;
            this.details.isMultiple = true;
            this.details.title = title;
            this.details.titleDescription = description;
            if (reports && reports.length > 0) {
                reports.forEach(function (report) {
                    _this.tabs.push(new MTab(report.name, report));
                });
                if (this.tabs[0]) {
                    this.tabs[0].active = true;
                }
            }
        }
    };
    CardDetailsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'card-details',
                    encapsulation: ViewEncapsulation.None,
                    template: "<div class=\"col-xs-12 analytics-card-details\">\n    <h2 [innerText]=\"details?.title\"></h2>\n    <p [innerText]=\"details?.titleDescription\"></p>\n    <div *ngIf=\"details?.reportInformations && details?.reportInformations.length > 1\">\n        <tabset>\n            <tab *ngFor=\"let tabz of tabs\"\n                (select)=\"tabz.active = true\"\n                [customClass]=\"tabz.active ? 'active-menu-item' : 'inactive-menu'\">\n                <ng-template tabHeading>\n                    <span [innerHtml]=\"tabz.title\"></span>\n                    <span [innerHtml]=\"tabz?.content?.componentDetails?.length || '0'\" class=\"badge\"></span>\n                </ng-template>\n                <report-information [genericInformation]=\"genericInformation\" [report]=\"tabz.content\" [repoInfo]=\"repoInfo\"></report-information>\n\n            </tab>\n        </tabset>\n    </div>\n    <div *ngIf=\"details?.reportInformations && details?.reportInformations.length === 1\">\n        <report-information [genericInformation]=\"genericInformation\" [report]=\"details?.reportInformations[0]\" [repoInfo]=\"repoInfo\"></report-information>\n    </div>\n    <div *ngIf=\"details?.reportInformations && details?.reportInformations.length === 0\">\n        <!-- Handle no information scenario -->\n    </div>\n</div>\n",
                    styles: [".stack-report .analytics-card-details .tab-container .nav-tabs{border:none;border-bottom:1px solid #ededed;background:#fff;color:#000}.stack-report .analytics-card-details .tab-container .nav-tabs .active-menu-item .nav-link.active{color:#39a5dc;font-weight:400;border:1px solid #ddd;border-bottom:1px solid #fff;box-shadow:unset}.analytics-card-details{border-top:2px solid #39a5dc}"]
                }] }
    ];
    CardDetailsComponent.propDecorators = {
        cardDetails: [{ type: Input }],
        genericInformation: [{ type: Input }],
        repoInfo: [{ type: Input }]
    };
    return CardDetailsComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var imports$3 = [
    ReportInformationModule,
    TabsModule.forRoot()
];
/** @type {?} */
var declarations$1 = [
    CardDetailsComponent
];
var CardDetailsModule = /** @class */ (function () {
    function CardDetailsModule() {
    }
    CardDetailsModule.decorators = [
        { type: NgModule, args: [{
                    imports: __spread([
                        CommonModule
                    ], imports$3),
                    declarations: __spread(declarations$1),
                    exports: __spread(declarations$1)
                },] }
    ];
    return CardDetailsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var revampImports = [
    ReportSummaryModule,
    CardDetailsModule
];
var StackDetailsModule = /** @class */ (function () {
    function StackDetailsModule() {
    }
    StackDetailsModule.decorators = [
        { type: NgModule, args: [{
                    imports: __spread([
                        CommonModule,
                        HttpClientModule,
                        FormsModule,
                        ModalModule,
                        PipelineInsightsModule,
                        AccordionModule.forRoot(),
                        TabsModule.forRoot()
                    ], revampImports),
                    declarations: [
                        StackDetailsComponent
                    ],
                    exports: [
                        StackDetailsComponent
                    ],
                    providers: [
                        GlobalConstants,
                        CommonService,
                        StackAnalysesService
                    ],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    /** @nocollapse */
    StackDetailsModule.ctorParameters = function () { return []; };
    return StackDetailsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
// require('../../node_modules/c3/c3');
/**
 *
 * This chart uses C3 for generating and rendering charts.
 *
 * Minimum Requirements:
 * C3, D3 (As C3 internally uses D3)
 *
 * Usage:
 * eg.) <f8-chart bind-data="dataFromTheComponentOrWherever"></f8-chart>
 *
 * 1. MultiLine chart takes the parameters
 *      a. data of c3 configuration
 */
var ChartComponent = /** @class */ (function () {
    function ChartComponent(elementReference) {
        // Below configs have been captured from C3 Reference Doc's Need 
        // to be updated if in case c3 includes new options
        this.c3Configs = [
            'axis',
            'tooltip',
            'grid',
            'legend',
            'zoom',
            'regions',
            'subchart'
        ];
        /**
         *  Below options have been captured from C3 Reference Doc's
         *  This doesnot include call back methods those options would be captured seperately
         */
        this.c3Options = [
            'size',
            'padding',
            'color',
            'interaction',
            'transition',
            'point',
            'line',
            'area',
            'bar',
            'pie',
            'donut',
            'gauge',
            'oninit',
            'onrendered',
            'onmouseover',
            'onmouseout',
            'onresize',
            'onresized'
        ];
        this.element = elementReference.nativeElement;
        // Adding the below line to specify CSS for the ng2-c3 selector
        this.element.className += ' ng2-c3';
    }
    // Checks for the changes made in the data and re-renders the charts accordingly
    // Checks for the changes made in the data and re-renders the charts accordingly
    /**
     * @return {?}
     */
    ChartComponent.prototype.ngOnChanges = 
    // Checks for the changes made in the data and re-renders the charts accordingly
    /**
     * @return {?}
     */
    function () {
        try {
            this.__render(this.data, this.chartOptions, this.configs);
        }
        catch (err) {
            console.log(err);
        }
    };
    /**
     * @private
     * @param {?} inputData
     * @param {?} chartOptionsData
     * @param {?} chartConfigsData
     * @return {?}
     */
    ChartComponent.prototype.__render = /**
     * @private
     * @param {?} inputData
     * @param {?} chartOptionsData
     * @param {?} chartConfigsData
     * @return {?}
     */
    function (inputData, chartOptionsData, chartConfigsData) {
        /** @type {?} */
        var _this = this;
        if (this.isValid(inputData)) {
            /** @type {?} */
            var c3InputData = {};
            c3InputData['bindto'] = _this.element;
            c3InputData['data'] = inputData;
            /**
             * Options for the charts provided
             * Options listed like axis, tooltip, grid, legend, zoom , point
             * Individual options are parsed and set in c3InputData Json
             * to be provided to c3
             */
            if (this.isValid(chartConfigsData)) {
                this.updateIfValidInput(chartConfigsData, c3InputData, this.c3Configs);
            }
            /*
             * Chart Configuration could have multiple Options
             * Size, padding, color Pattern, Transition
             * Some callback initializers like OnInit, Onrendered, OnMouseOver, OnMouseOut
             *
             */
            if (this.isValid(chartOptionsData)) {
                this.updateIfValidInput(chartOptionsData, c3InputData, this.c3Options);
            }
            /**
             * Should find a way to check for proper inputs
             * if(!this.isValidInput(c3InputData)) {
             *     throw new Error('Invalid Configuration passed');
             * }
             *
             */
            generate(c3InputData);
            // Generates the C3 chart for the given configuration 
            // and places it inside the directive's element.
        }
    };
    // A utility method to check if a provided value is valid
    // A utility method to check if a provided value is valid
    /**
     * @private
     * @param {?} randomInput
     * @return {?}
     */
    ChartComponent.prototype.isValid = 
    // A utility method to check if a provided value is valid
    /**
     * @private
     * @param {?} randomInput
     * @return {?}
     */
    function (randomInput) {
        return randomInput !== undefined && randomInput !== null;
    };
    /**
     * A utility method to traverse through teh input map, checks with the given config
     *  Updates the  output map if input is present in config
     *  skips the field if the given input is not present in config map
     *
     */
    /**
     * A utility method to traverse through teh input map, checks with the given config
     *  Updates the  output map if input is present in config
     *  skips the field if the given input is not present in config map
     *
     * @private
     * @param {?} inputMap
     * @param {?} outputMap
     * @param {?} config
     * @return {?}
     */
    ChartComponent.prototype.updateIfValidInput = /**
     * A utility method to traverse through teh input map, checks with the given config
     *  Updates the  output map if input is present in config
     *  skips the field if the given input is not present in config map
     *
     * @private
     * @param {?} inputMap
     * @param {?} outputMap
     * @param {?} config
     * @return {?}
     */
    function (inputMap, outputMap, config) {
        for (var key in inputMap) {
            if (inputMap.hasOwnProperty(key)) {
                /** @type {?} */
                var isValidOption = config.indexOf(key);
                if (isValidOption >= 0) {
                    outputMap[key] = inputMap[key];
                }
            }
        }
    };
    ChartComponent.decorators = [
        { type: Component, args: [{
                    selector: 'f8-chart',
                    template: "",
                    encapsulation: ViewEncapsulation.None,
                    inputs: ['data', 'chartOptions', 'configs'],
                    styles: [".ng2-c3 {\n            display:block; // This is required for proper positioning of tooltip\n        }\n        "]
                }] }
    ];
    /** @nocollapse */
    ChartComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    return ChartComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChartModule = /** @class */ (function () {
    function ChartModule() {
    }
    ChartModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        ChartComponent
                    ],
                    exports: [
                        ChartComponent
                    ]
                },] }
    ];
    return ChartModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StackReportInShortComponent = /** @class */ (function () {
    function StackReportInShortComponent(stackAnalysisService, commonService) {
        this.stackAnalysisService = stackAnalysisService;
        this.commonService = commonService;
        this.tabs = [];
        this.dataLoaded = false;
        this.cache = '';
        this.reportSummaryUtils = new ReportSummaryUtils();
    }
    /**
     * @return {?}
     */
    StackReportInShortComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.stackUrl && this.stackUrl !== this.cache) {
            this.cache = this.stackUrl;
            this.dataLoaded = false;
            console.log('inshort component', this.stackUrl, this.gatewayConfig);
            this.stackAnalysisService
                .getStackAnalyses(this.stackUrl, this.gatewayConfig)
                .subscribe(function (data) {
                if (data && (!data.hasOwnProperty('error') && Object.keys(data).length !== 0)) {
                    /** @type {?} */
                    var resultInformation = getStackReportModel(data);
                    if (resultInformation) {
                        resultInformation.subscribe(function (response) {
                            _this.result = response;
                            _this.buildReportInShort();
                        });
                    }
                }
                else if (data && data.hasOwnProperty('error')) {
                    // Handle Errors here 'API error'
                    _this.handleProgress({
                        title: 'Analysis for your stack is in progress...'
                    });
                }
                else {
                    // Handle Errors here 'API error'
                    _this.handleError({
                        title: 'We encountered an unexpected server error',
                        detail: data['error']
                    });
                }
            }, function (error) {
                // Handle server errors here
                _this.handleError({
                    title: 'We encountered an unexpected server error'
                });
            });
        }
    };
    /**
     * @param {?} error
     * @return {?}
     */
    StackReportInShortComponent.prototype.handleError = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        this.error = error;
        this.dataLoaded = true;
    };
    /**
     * @param {?} data
     * @return {?}
     */
    StackReportInShortComponent.prototype.handleProgress = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.progress = data;
        this.dataLoaded = true;
    };
    /**
     * @param {?} tab
     * @return {?}
     */
    StackReportInShortComponent.prototype.tabSelection = /**
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        tab['active'] = true;
        /** @type {?} */
        var currentIndex = tab['index'];
        this.stackLevel = tab.content.user_stack_info;
        this.recommendations = tab.content.recommendation;
        if (this.recommendations) {
            this.stackLevelOutliers = {
                'usage': this.recommendations.usage_outliers
            };
        }
        this.handleLicenseInformation(this.stackLevel);
        this.handleSecurityInformation(this.stackLevel);
    };
    /**
     * @param {?} cardDetails
     * @return {?}
     */
    StackReportInShortComponent.prototype.handleCardClick = /**
     * @param {?} cardDetails
     * @return {?}
     */
    function (cardDetails) {
        this.commonService.shortCardClicked();
    };
    /**
     * @private
     * @param {?} array
     * @return {?}
     */
    StackReportInShortComponent.prototype.sortChartColumnData = /**
     * @private
     * @param {?} array
     * @return {?}
     */
    function (array) {
        return array.sort(function (a, b) {
            if (a[1] === b[1]) {
                return 0;
            }
            return a[1] > b[1] ? -1 : 1;
        });
    };
    /**
     * @private
     * @param {?} tab
     * @return {?}
     */
    StackReportInShortComponent.prototype.handleSecurityInformation = /**
     * @private
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        /** @type {?} */
        var dependencies = tab.analyzed_dependencies;
        /** @type {?} */
        var security = [];
        /** @type {?} */
        var temp = [];
        dependencies.forEach(function (dependency) {
            security = dependency.security;
            if (security && security.length > 0) {
                /** @type {?} */
                var max = security.reduce(function (a, b) {
                    return parseFloat(a['CVSS']) < parseFloat(b['CVSS']) ? b : a;
                });
                temp.push({
                    name: dependency.name,
                    cve: max
                });
            }
        });
        if (temp.length > 0) {
            /** @type {?} */
            var final = temp.reduce(function (a, b) {
                return parseFloat(a['cve']['CVSS']) < parseFloat(b['cve']['CVSS']) ? b : a;
            });
            /** @type {?} */
            var cvssValue = final.cve.CVSS;
            /** @type {?} */
            var iconClass = 'fa fa-shield';
            /** @type {?} */
            var displayClass = 'progress-bar-warning';
            if (cvssValue >= 7.0) {
                iconClass = 'fa fa-shield';
                displayClass = 'progress-bar-danger';
            }
            this.securityInfo = {
                name: final.name,
                cve: final.cve,
                percentage: final.cve.CVSS * 10,
                status: final.cve.CVSS < 7 ? 'moderate' : 'critical',
                iconClass: iconClass,
                displayClass: displayClass
            };
        }
    };
    /**
     * @private
     * @param {?} tab
     * @return {?}
     */
    StackReportInShortComponent.prototype.handleLicenseInformation = /**
     * @private
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        this.licenseAnalysis = {
            licenseOutliersCount: 0,
            licenseStackConflictCount: 0,
            licenseComponentConflictCount: 0,
            licenseUnknownCount: 0,
            stackLicenseText: '',
            status: ''
        };
        if (tab.license_analysis) {
            this.licenseAnalysis.licenseOutliersCount =
                tab.license_analysis.outlier_packages ?
                    tab.license_analysis.outlier_packages.length : 0;
            this.licenseAnalysis.licenseStackConflictCount =
                tab.license_analysis.conflict_packages ?
                    tab.license_analysis.conflict_packages.length : 0;
            if (tab.license_analysis.unknown_licenses) {
                this.licenseAnalysis.licenseUnknownCount =
                    tab.license_analysis.unknown_licenses.really_unknown ?
                        tab.license_analysis.unknown_licenses.really_unknown.length : 0;
                this.licenseAnalysis.licenseComponentConflictCount =
                    tab.license_analysis.unknown_licenses.component_conflict ?
                        tab.license_analysis.unknown_licenses.component_conflict.length : 0;
            }
            this.licenseAnalysis.stackLicenseText = tab.license_analysis.f8a_stack_licenses[0];
            if (tab.license_analysis.status) {
                this.licenseAnalysis.status = tab.license_analysis.status;
            }
            else {
                this.licenseAnalysis.status = 'nolicensedata';
            }
        }
    };
    /**
     * @private
     * @return {?}
     */
    StackReportInShortComponent.prototype.resetFields = /**
     * @private
     * @return {?}
     */
    function () {
        this.securityInfo = null;
        this.stackLevelOutliers = null;
        this.stackLevel = null;
        this.licenseAnalysis = null;
    };
    /**
     * @private
     * @return {?}
     */
    StackReportInShortComponent.prototype.buildReportInShort = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this.resetFields();
        /** @type {?} */
        var resultInformation = this.result.result;
        if (resultInformation && resultInformation.length > 0) {
            resultInformation.forEach(function (one, index) {
                /** @type {?} */
                var warning = _this.ifManifestHasWarning(one);
                _this.tabs[index] = {
                    title: one.manifest_file_path,
                    content: one,
                    index: index,
                    hasWarning: warning.has,
                    severity: warning.severity
                };
            });
            if (this.tabs[0])
                this.tabs[0]['active'] = true;
            this.tabSelection(this.tabs[0]);
            this.dataLoaded = true;
            this.error = null;
        }
    };
    /**
     * @private
     * @param {?} manifest
     * @return {?}
     */
    StackReportInShortComponent.prototype.ifManifestHasWarning = /**
     * @private
     * @param {?} manifest
     * @return {?}
     */
    function (manifest) {
        /** @type {?} */
        var securityInfo = this.reportSummaryUtils.getSecurityReportCard(manifest.user_stack_info);
        /** @type {?} */
        var isSecurityWarning = securityInfo.hasWarning;
        /** @type {?} */
        var isInsightsWarning = this.reportSummaryUtils.getInsightsReportCard(manifest.recommendation).hasWarning;
        /** @type {?} */
        var isLicenseWarning = this.reportSummaryUtils.getLicensesReportCard(manifest.user_stack_info).hasWarning;
        return {
            has: isSecurityWarning || isInsightsWarning || isLicenseWarning,
            severity: (isSecurityWarning && securityInfo.severity) || 2
        };
    };
    StackReportInShortComponent.decorators = [
        { type: Component, args: [{
                    selector: 'stack-report-inshort',
                    // providers: [StackAnalysesService],
                    encapsulation: ViewEncapsulation.None,
                    template: "<div class=\"stack-report-inshort\">\n  <div *ngIf=\"!error || !progress\">\n    <tabset *ngIf=\"tabs && tabs.length > 0\">\n      <tab *ngFor=\"let tabz of tabs\" (select)=\"tabSelection(tabz)\"\n        [customClass]=\"tabz.active ? 'active-menu-item' : 'inactive-menu'\">\n        <ng-template tabHeading>\n          <i *ngIf=\"tabz.hasWarning\" [ngClass]=\"{'pficon-warning-triangle-o': true, 'icon-severe': tabz.severity === 1, 'icon-moderate': tabz.severity === 2}\"></i>\n          <span [innerHtml]=\"tabz.title\" style=\"margin-left: 5px\"></span>\n        </ng-template>\n        <!-- Stack Report Design Revamp - BEGIN -->\n        <div class=\"row info-row\">\n          <div class=\"col-sm-7\">\n            Dependencies: [\n            <b>Total: {{stackLevel && stackLevel.dependencies && stackLevel.dependencies.length}}</b> |\n            <b>Analyzed: {{stackLevel && stackLevel.analyzed_dependencies && stackLevel.analyzed_dependencies.length}}</b> |\n            <b>Unknown: {{stackLevel && stackLevel.unknown_dependencies && stackLevel.unknown_dependencies.length}}</b>]\n          </div>\n          <div class=\"col-sm-5\">\n            <stack-details *ngIf=\"result\" class=\"report-link\" [showFlags]=\"'false'\" [buildNumber]=\"buildNumber\" [appName]=\"appName\" [displayName]=\"'View complete stack report'\"\n              [repoInfo]=\"repoInfo\" [stackResponse]=\"result && result\" [gatewayConfig]=\"gatewayConfig && gatewayConfig\" [stack]=\"stackUrl\"></stack-details>\n          </div>\n        </div>\n        <analytics-report-summary [report]=\"tabz.content\" [isFromShortReport]=\"'true'\" (onCardClick)=\"handleCardClick($event)\"></analytics-report-summary>\n        <!-- Stack Report Design Revamp - END -->\n      </tab>\n    </tabset>\n    <div *ngIf=\"!dataLoaded\" class=\"pre-loader\">\n      <div class=\"pre-loader-spinner spinner spinner-lg\"></div>\n    </div>\n  </div>\n  <div *ngIf=\"error\" class=\"error-class\">\n    <div class=\"f8-blank-slate-card\">\n      <div class=\"f8-blank-slate-icon\">\n        <i class=\"pficon pficon-warning-triangle-o\"></i>\n      </div>\n      <h3>{{error && error.title}}</h3>\n      <p>{{error && error.detail}}</p>\n      <p>Switch to the Pipelines view to restart the pipeline:\n        <b>{{pipeline}}</b>\n      </p>\n    </div>\n  </div>\n  <div *ngIf=\"progress\" class=\"error-class\">\n    <div class=\"container-progress progress\">\n      <div class=\"progress-bar\" role=\"progressbar\" aria-valuenow=\"50\" aria-valuemin=\"0\" aria-valuemax=\"100\" style=\"width: 50%;\">\n        <span>50%</span>\n      </div>\n    </div>\n    <h3>{{progress && progress.title}}</h3>\n  </div>\n</div>\n",
                    styles: [".stack-report-inshort{padding:unset}.stack-report-inshort .tab-container .nav-tabs{border:none;background:#030303;color:#fff}.stack-report-inshort .tab-container .nav-tabs .active-menu-item .nav-link.active{background-color:inherit;color:inherit;border:none;box-shadow:inset -10px -14px 0 -10px #39a5dc}.stack-report-inshort .tab-container .nav-tabs li a{border:0}.stack-report-inshort .tab-container .nav-tabs li a:hover{border:0;color:inherit}.stack-report-inshort .tab-container .tab-content{padding:0 20px}.stack-report-inshort .tab-container .icon-moderate:before{color:#f5a625}.stack-report-inshort .tab-container .icon-severe:before{color:#d1011c}.stack-report-inshort .analytics-summary-report .analytics-summary-card .card-pf{border:1px solid #ddd;box-shadow:none}.stack-report-inshort .error-class{background:#fff;border:none;text-align:center}.stack-report-inshort .error-class .container-progress{width:50%;margin:100px auto 0}.stack-report-inshort .center-text{margin:0 auto;text-align:center}.stack-report-inshort .pre-loader{position:absolute;top:0;left:0;bottom:0;right:0;background:rgba(255,255,255,.5);z-index:99}.stack-report-inshort .pre-loader .pre-loader-spinner{top:50%}.stack-report-inshort .info-row{padding:10px 0}.stack-report-inshort .info-row .report-link{float:right}"]
                }] }
    ];
    /** @nocollapse */
    StackReportInShortComponent.ctorParameters = function () { return [
        { type: StackAnalysesService },
        { type: CommonService }
    ]; };
    StackReportInShortComponent.propDecorators = {
        gatewayConfig: [{ type: Input }],
        stackUrl: [{ type: Input }],
        repoInfo: [{ type: Input }],
        buildNumber: [{ type: Input }],
        appName: [{ type: Input }],
        pipeline: [{ type: Input }]
    };
    return StackReportInShortComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var StackReportInShortModule = /** @class */ (function () {
    function StackReportInShortModule() {
    }
    StackReportInShortModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        ChartModule,
                        StackDetailsModule,
                        TabsModule.forRoot(),
                        ReportSummaryModule
                    ],
                    declarations: [StackReportInShortComponent],
                    exports: [StackReportInShortComponent],
                    providers: [CommonService, StackAnalysesService]
                },] }
    ];
    return StackReportInShortModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { StackDetailsModule, StackReportInShortModule, StackAnalysesService, getStackReportModel, AuditInformationModel, ComponentInformationModel, GithubModel, OutlierInformationModel, RecommendationsModel, ResultInformationModel, SentimentModel, StackReportModel, UserStackInfoModel, CardDetailsComponent as ɵbd, CardDetailsModule as ɵq, ComponentDetailsComponent as ɵba, ComponentInformationComponent as ɵy, ComponentSnippetComponent as ɵx, NoDataComponent as ɵbc, ReportInformationComponent as ɵbb, ReportInformationModule as ɵr, GlobalConstants as ɵd, PipelineInsightsComponent as ɵb, PipelineInsightsModule as ɵa, PipelineInsightsService as ɵc, ReportSummaryCardComponent as ɵn, ReportSummaryCardDirective as ɵo, ReportSummaryCardModule as ɵf, ReportSummaryInfoEntriesComponent as ɵj, ReportSummaryContentComponent as ɵk, ReportSummaryContentModule as ɵg, ReportSummaryDescriptionComponent as ɵm, ReportSummaryTitleComponent as ɵl, ReportSummaryComponent as ɵp, ReportSummaryModule as ɵe, AddWorkFlowService as ɵz, StackDetailsComponent as ɵbe, StackReportInShortComponent as ɵbi, ToastNotificationComponent as ɵu, ToastNotificationModule as ɵt, ChartComponent as ɵbh, ChartModule as ɵbg, CommonService as ɵbf, ComponentFeedbackComponent as ɵv, ComponentFeedbackModule as ɵs, ComponentFeedbackService as ɵw, ProgressMeterComponent as ɵi, ProgressMeterModule as ɵh };

//# sourceMappingURL=fabric8-stack-analysis-ui.js.map